# Ideen fuer weitere Grafiken: 
  # kummulierter demand in TWh -> bietet Vergleichsmöglichkeit mit production
  # eine  Grafik zur Gesamttransportmenge pro Leitung, da die exchange-Grafiken  bisher nur die Häufigkeit zeigen, aufgrund der kleinen Darstellung  jedoch nicht zu erkennen ist, in welche Richtung die Leitung mehr  benutzt wird
  # elp je Monat
  # elp_pump noch in das elp_bild rein
  # Strompreis
  # cost_fos_t 	<- price_exchange * # Kosten der Treppe unter der Merit Order (Cmar/bmo code aufrufen?)

# R_figure_group_1
# geaendert von frauke
# am 041012

# Folgende Grafiken:
  # demand
  # ee_reduction
  # ee_reduction_pump
  # elp_pump
  # over_demand
  # price_exchange
  # price_start
  # residual_load
  # elp_fuel_by_source
  # elp_fuel_by_region
  # elp_by_source_and_demand
  # filling_level_de
  # filling_level_no
  # spil_no
  # filling_level_and_spil_no
  # exchange
  # exchange_1->2 (fuer jede Regionen-Verbindung)
  # pump_exchange
  # map_exchange
#--------------------------

#---------------
# Einstellungen: hier selber aendern
#---------------
if("make_figures" %in% ls() == FALSE){

  pfad 			<- "C:/Users/EUM/Energiesystem" # wo liegt der Ordner renpass auf Deinem Rechner?
  scenario_nr_vector 	<- c(7171) # hier die Szenarien reinschreiben von denen man die Grafiken haben will
  figure_file_type 	<- "jpeg" # moeglich: "jpeg" "pdf" "png" "eps" Format der Ausgabe-Grafiken
  breite        <- 480 # Hoehe der Grafik in Pixel
  hoehe         <- 480 # Breite der Grafik in Pixel
  own_colors 		<- 0 # bei Bedarf kann man sich hier selbst Farben auswaehlen fur die Regionen
  big_figures 		<- FALSE # die Grafiken elp (Electricity Production) und map_exchange (Netzfluesse mit Karte im Hintergrund) dauern recht lang und werden nur gemacht wenn hier TRUE steht, sonst FALSE eintragen

}else{
#-----------------------
# Standardeinstellungen: hier nur aendern wenn man es standardmaessig geaender werden soll
#-----------------------
# wenn die Grafiken automatisch nach der Berechnung erzeugt werden (make_figures <- TRUE), kommen diese zum Einsatz 
# HIER NUR WAS VERANEDERN WENN ES STANDARDMAESSIG FUER ALLE GRAFIKEN DER GRUPPE 1 GEÄNDERT WERDEN SOLL
#--------------------------
  breite        <- 480
  hoehe         <- 480
  own_colors 		<- 0 # Standardfarben
  big_figures 		<- FALSE # dauert sonst zu lange
  figure_file_type 	<- "jpeg" # braucht den wenigsten Speicherplatz
}
#--------------------------
# Funktion definieren, damit man beim Starten einer Grafik nur noch start <- f_start_figure() schreiben muss. Im Normalfall kann man dann einfach start <- f_start_figure(tab_name) schreiben und dann kommt automatisch die scenario_nr dazu im Namen, sollte man einen anderen Namen wollen geht das auch
f_start_figure <- function(tab_name){ 
  if(figure_file_type == "eps"){
    a <- parse(text = paste("postscript(file = 'figure_sc", scenario_nr,"_",tab_name, ".",figure_file_type,"')", sep = ""))
  }else{
    a <- parse(text = paste(figure_file_type,"(file = 'figure_sc", scenario_nr,"_",tab_name, ".",figure_file_type, "', width = ",breite,", height = ",hoehe,")", sep = ""))
  }
  return(eval(a))
}

#---------------------
# ERGEBNISSE EINLESEN
#---------------------

# Szenario Parameter auslesen

setwd(paste(pfad, "/renpass/code_R_baltic", sep = ""))
source("code_R_mysql_connection.R")

for(sc in scenario_nr_vector){

  sql_scenario 		<- paste("SELECT * FROM scenario_nr WHERE scenario_nr = '",sc,"' ",sep = "")
  scenario_parameter 	<- dbGetQuery(con_scenarios, sql_scenario)
  parameter_names 	<- colnames(scenario_parameter)

  # da es inzwischen so viele scenario_parameters sind werden automatisiert 
  # in der Schleife alle als verwendbare Variable gemacht
  for(para_name in parameter_names[c(1:3,6, 10:11,13:22,25:26)]){ # jeder Paramter als eigene Variable (zahlen)
    a <- parse(text = paste(para_name," <- as.numeric(scenario_parameter$",para_name,")", sep = ""))
    eval(a)
  }
  for(para_name in parameter_names[-c(1:3,6, 10:11,13:22,25:26)]){ # jeder Paramter als eigene Variable (woerter)
    a <- parse(text = paste(para_name," <- scenario_parameter$",para_name, sep = ""))
    eval(a)
  }

  timesteps 		<- end_timestep - start_timestep + 1
  timesteps_vector <- c(1:timesteps)
  
  setwd(paste(pfad, "/renpass/code_R_baltic", sep = ""))
  source("code_R_timevector_for_scenario_year")
  source("code_R_prep_regions.R")
  source("code_R_prep_grid.R")

dir.create(paste(pfad, "/renpass/figures/figures_",scenario_nr, sep = ""))
 # setwd(paste(pfad, "/renpass/figures", sep = ""))
setwd(paste(pfad, "/renpass/figures/figures_",scenario_nr, sep = ""))

  # nun die Ergebnistabellen auslesen
  con_results 		<- dbConnect("MySQL", user ="root", password = "user123", dbname = paste("results", sep = ""))
  table_names 		<- dbListTables(con_results)
  
  table_names_2   <- c("elp_fuel","economics_grid", "economics_pp", "economics_pump", "exchange", "exchange_pump", "filling_level", "filling_level_other", "spil", "elp_single_pp", "elp_single_pump", "filling_level_single_res")
  idx_table_2     <- which(table_names %in% table_names_2)
  
  table_names_1   <- table_names[-idx_table_2]
  

  # alle Tabellen die es in der Ergebnisdatenbank gibt für diese scenario_nr werden ausgelesen und 
  # der data.frame bekommt den Namen je Tabelle
  for(tab_name in table_names_2){
    sql_result_table 	<- paste("SELECT * FROM ",tab_name," WHERE scenario_nr = '",scenario_nr,"'", sep ="")
    a <- parse(text = paste(tab_name," <- dbGetQuery(con_results,sql_result_table)",sep = ""))
    eval(a)
  }

  for(tab_name in table_names_1){
    sql_result_table   <- paste("SELECT * FROM ",tab_name," WHERE scenario_nr = '",scenario_nr,"' AND timestep <= ",timesteps," ORDER BY timestep, region", sep ="")
    a <- parse(text = paste(tab_name," <- dbGetQuery(con_results,sql_result_table)",sep = ""))
    eval(a)
    a <- parse(text = paste(tab_name," <- data.frame(cbind(sc, timesteps_vector, matrix(",tab_name,"$",tab_name,", ncol = ",region_split,", byrow = TRUE)))", sep = ""))
    eval(a)
    a <- parse(text = paste("colnames(",tab_name,") <- c('scenario_nr', 'timestep', as.character(regions))", sep = ""))
    eval(a)
  }
  
    # jetzt haben alle Tabellen des gewaehlten Szenarios in R als data.frame mit ihrem jeweiligen Tabellennamen.

  #----------------------
  # GRAFISCHE AUSWERTUNG
  #----------------------
  
  #--------------------------------------------------------------------
  # DEMAND / EE_REDUCTION / EE_REDUCTION_PUMP / ELP_PUMP / OVER_DEMAND / PRICE_EXCHANGE / PRICE_START / RESIDUAL_LOAD
  #--------------------------------------------------------------
  # alle mit der Struktur scenario_nr/quarter/region_1/region_2/ 
  #--------------------------------------------------------------------
  table_names_1 		<- c("demand", "ee_reduction", "ee_reduction_pump", "elp_pump", "over_demand", "price_exchange", "price_start", "residual_load")

  farbe <- rainbow(region_split) # je Region eine Farbe aus dem Regenbogen
  if(length(own_colors) > 1){farbe <- own_colors} # oder die selbstausgewaehlten

  price_min <- min(c(unlist(price_start[,3:(region_split+2)]), unlist(price_exchange[,3:(region_split+2)]))) 
  price_max <- max(c(unlist(price_start[,3:(region_split+2)]), unlist(price_exchange[,3:(region_split+2)])))
  
  # in der Schleife wird fuer jeden Tabelle in table_names_1 eine Grafik gemacht

  for(tab_name in table_names_1){
    # Sortierung nach der Stunde
    a <- parse(text = paste(tab_name," <- ",tab_name,"[order(",tab_name,"$timestep),]",sep = ""))
    eval(a)

    # Grafikdatei oeffnen
    start <- f_start_figure(tab_name)

    # losplotten, die erste Linie
    a <- parse(text = paste("plot(timevector_",time_unit,"[start_timestep:end_timestep],",tab_name,"[,3], type = 'l', col = farbe[1], ylim = c(min(",tab_name,"[,3:",region_split+2,"]), (max(",tab_name,"[,3:",region_split+2,"])*1.2)),main = '",tab_name,"',xlab = '',ylab = 'MW', lwd = 2)",sep = ""))

    if(tab_name %in% c("ee_reduction", "ee_reduction_pump")){
    a <- parse(text = paste("plot(timevector_",time_unit,"[start_timestep:end_timestep],",tab_name,"[,3], type = 'l', col = farbe[1], ylim = c(min(",tab_name,"[,3:",region_split+2,"]), (max(",tab_name,"[,3:",region_split+2,"])+ 0.15 * abs(min(",tab_name,"[,3:",region_split+2,"])))),main = '",tab_name,"',xlab = '',ylab = 'MW', lwd = 2)",sep = ""))
    } 

    if(tab_name %in% c("price_start", "price_exchange")){
      a <- parse(text = paste("plot(timevector_",time_unit,"[start_timestep:end_timestep],",tab_name,"[,3], type = 'l', col = farbe[1], ylim = c(price_min,price_max*1.2), main = '",tab_name,"',xlab = '',ylab = 'Euro/MWh', lwd = 2)",sep = ""))
    }
    eval(a)
    # nun die Linien fuer die anderen Regionen, so viele wie es Regionen gibt, in der Schleife
    for(reg in 2:region_split){
      b <- parse(text = paste("lines(timevector_",time_unit,"[start_timestep:end_timestep],",tab_name,"[,2+",reg,"],col = farbe[",reg,"], lwd = 2)",sep = ""))
      eval(b)
    }
    # Legende
    
    legend("top",(paste("region",c(1:region_split),sep = "_")), col = farbe, lwd = 3, cex = 0.8, bty = "n", ncol = round(region_split/3))
   
    dev.off()
  }

  #---------------------------------------
  # ELP_FUEL_BY_TYPE / ELP_FUEL_BY_REGION
  #---------------------------------------

  # Vorbereitung fuer alle elp_fuel Grafiken
  # if(big_figures){
    elp_fuel_ordered_by_region <- elp_fuel[order(elp_fuel$region),]
    fuels   	<- unique(elp_fuel$fuel) # diese fuels kommen in der Ergebnistabelle vor
    region_names <- unique(elp_fuel_ordered_by_region$region)
    elp_fuel_werte <- matrix(elp_fuel_ordered_by_region$elp_fuel, nrow = timesteps*length(fuels))
    elp_fuel_vor <- cbind(elp_fuel_ordered_by_region[1:(timesteps*length(fuels)),2:3],elp_fuel_werte)
    colnames(elp_fuel_vor) <- c("timestep","fuel",region_names)
    # Funktion definieren die als Eingang den fuel-type hat und die uebers Jahr aufsummierte Stromproduktion ausgibt
    f_elp_year 		<- function(x){colSums(subset(elp_fuel_vor[,3:(region_split+2)], elp_fuel_vor$fuel == x))}
    elp_year 		<- sapply(fuels,f_elp_year) / 1000000
    fuel_order 		<- c("wind_onshore", "wind_offshore", "solar", "biomass", "run_of_river", "geothermal", "hydro", "lignite", "hard_coal",  "gas", "uran", "ref",  "oil", "other")
    reihenfolge 	<- match(fuel_order,fuels)
    elp_year 		<- elp_year[,reihenfolge]
    energy_source 	<- c("wind onshore", "wind offshore","solar", "biomass", "run-of-river", "geothermal",  "hydro", "lignite","hard coal", "gas", "uranium", "waste", "oil", "other")
    colnames(elp_year) 	<- energy_source
    elp_year_region 	<- elp_year
    elp_year_fuel 	<- t(elp_year_region)
    farbe_fuel 		<- c('lightblue2', 'steelblue2', 'yellow', 'forestgreen', 'blue', 'orange', 'darkblue', 'chocolate','black', 'red', 'purple', 'grey', 'hotpink','springgreen')
    colnames(elp_year_fuel) <- region_names
    idx_na 		<- which(is.na(elp_year_fuel) == TRUE)
    elp_year_fuel[idx_na] <- 0
    elp_year_total 	<- colSums(elp_year_fuel)
    demand_total 	<- colSums(demand[,3:(region_split+2)]) / 1000000
    elp_demand_year 	<- rbind(elp_year_total, demand_total)
    colnames(elp_demand_year) <- region_names

    #-----------------------------------------
    # Electricity production by source and region for the whole year
    #-----------------------------------------
    # Grafikdatei oeffnen
    start <- f_start_figure("elp_fuel_by_source")

    barplot(elp_year_fuel, col = farbe_fuel, ylab = "TWh", xlab = "", main = "Electricity Production by source and region")
    legend("top",rownames(elp_year_fuel), col = farbe_fuel, lwd = 5, bty = "n", cex = 0.9, ncol = 2)
    dev.off()

    #-----------------------------------------
    # Electricity production total by region and demand for the whole year
    #-----------------------------------------
    # Grafikdatei oeffnen
    start <- f_start_figure("elp_and_demand")

    barplot(rbind(elp_year_total,demand_total),  ylab = "TWh", xlab = "", main = "Electricity Production and Demand", beside = TRUE, col = c("springgreen", "darkred"))
    legend("top",c("Production","Demand"), col = c("springgreen", "darkred"), lwd = 5, bty = "n", cex = 0.9, ncol = 2)
    dev.off()

    #-------------------------------------------
    # Electricity production by region and source for thw whole year
    #-------------------------------------------
  
    # Grafikdatei oeffnen
    start <- f_start_figure("elp_fuel_by_region")
    standard <- par() # Standard-Einstellungen vom Anfang
    par(mar = c(8, 4, 4, 2) + 0.1) # unten mehr Rand damit x-Achse Beschriftung nicht abgeschnitten

    barplot(elp_year_region, col = farbe, ylab = "TWh", xlab = "", main = "Electricity Production by region and source", las = 2)
    legend("topright",as.character(c(1:region_split)), col = farbe, lwd = 5, bty = "n",  title = "region", xjust = 0)
  
    par <- standard # zurueck zu Standard-Einstellungen
    dev.off()

    #-----------------------------------------------------------------------
    # electricity production by source and demand summed up for all regions
    #-----------------------------------------------------------------------
  
    demand_sum 			<- rowSums(demand[,3:(region_split+2)]) / 1000
    elp_fuel_sum 		<- data.frame(elp_fuel_vor$timestep, elp_fuel_vor$fuel,rowSums(elp_fuel_vor[,3:(region_split+2)]))
    colnames(elp_fuel_sum) 	<- c("timestep","fuel","sum")
    elp_cum 			<- matrix(ncol = length(fuel_order), nrow = timesteps)
    colnames(elp_cum) 		<- energy_source
    for(fu in 1:length(fuel_order)){
      a 			<- subset(elp_fuel_sum, fuel == fuel_order[fu], select = sum)
      a 			<- a[,1] / 1000
      if(length(a) == 0){a <- rep(0,timesteps)}
      elp_cum[,fu] 		<- a
    }
   
    elp_cum_2 		<- t(apply(elp_cum, 1,cumsum))
  
    a <- parse(text= paste("timevector",time_unit, sep = "_"))
    timevector <- eval(a)
  
    # Grafikdatei oeffnen
    if(timesteps <= 4){a <- 10} # Breite der bars
    if(4 < timesteps & timesteps <= 24){a <- 3}
    if(24 < timesteps){a <- 1}
    start <- f_start_figure("elp_by_source_and_demand")

    plot(timevector[start_timestep:end_timestep], elp_cum_2[,length(energy_source)], type = "h", col = "black", ylim = c(0,max(demand_sum,elp_cum_2)*1.3), ylab = "GW", lwd = a, main = "Electricity Production \n by source and demand")
    for(fu in length(energy_source):1){
      lines(timevector[start_timestep:end_timestep],elp_cum_2[,fu], col = farbe_fuel[fu], type = "h", lwd = a)
    }
    lines(timevector[start_timestep:end_timestep], demand_sum, type = "l", col = "firebrick", lwd = 2, lty = 2)
    legend("top", c(colnames(elp_cum_2), "demand"), col = c(farbe_fuel,"firebrick"), bty = "n", cex= 0.8, lwd = 4, ncol = 3, lty = c(rep(1,length(farbe_fuel)),2))
    dev.off()
  #}
  #-----------------------------------------------
# Grafiken fuer filling_level und den Ueberlauf
  #-----------------------------------------------
  filling_level_o <- filling_level[order(filling_level$region),]
  fl_r_names <- unique(filling_level_o$region)
  filling_level_matrix <- matrix(filling_level_o$filling_level, ncol = length(fl_r_names))
  filling_level_vor <- cbind(filling_level_o[1:(timesteps+1),2:3],filling_level_matrix)  
  colnames(filling_level_vor) <- c("timestep","region",fl_r_names)  
      
  # Grafikdatei oeffnen
  start <- f_start_figure("filling_level")
    
  plot(timevector[start_timestep:(end_timestep+1)],filling_level_vor[,3],type = "l", ylab = "cbm water", col = farbe[1], ylim = c(0,max(filling_level_matrix)),main = "Filling Level")
  for(fl in 2:length(fl_r_names)){
      lines(timevector[start_timestep:(end_timestep+1)],filling_level_vor[,1+fl], col = farbe[fl])
  }
  legend("bottom",paste("region_",fl_r_names,sep =""),col = farbe[1:length(fl_r_names)],lwd = 3)
  dev.off()

  start <- f_start_figure("spil")
  plot(timevector[start_timestep:(end_timestep)],spil$spil,type = "l", ylab = "cbm water", col = farbe[1],main = "Spil Over")
  dev.off()
  
  #------------------------------
  # filling_level_and_spil Norway
  #------------------------------
  if(area != "de"){
    idx <- which(fl_r_names %in% c(9,900)) 
    fln 	<- filling_level_vor[((start_timestep+1):(end_timestep+1)),2+idx]
    flns 	<- fln + spil$spil
  
    # Grafikdatei oeffnen
    start <- f_start_figure("filling_level_and_spil_no")  
    plot(timevector[start_timestep:end_timestep],fln, col = "blue", type = "l", ylim = c(0,max(flns,na.rm = TRUE)*1.2), main = "Filling level and spil-over", ylab = 'Mio cbm')
    xx 	<- c(timevector[start_timestep:end_timestep], rev(timevector[start_timestep:end_timestep]))
    yy 	<- c(rep(0, (length(timevector[start_timestep:end_timestep]))), rev(fln))
    polygon(xx, yy, col = "blue", border = NA)
    lines(timevector[start_timestep:end_timestep], flns , col = "red", lwd = 2.5) 
    legend("topleft", c("filling_level", "additional water, not used"), col = c("blue","red"), bty = "n", lwd = 5) 

    dev.off()
  }
  #----------------------------------------
  # Grafik fuer exchange und exchange_pump
  #----------------------------------------
  gridlines 		<- unique(paste(exchange$plus_region,"_to_",exchange$minus_region,sep = ""))
  if (region_split == 3) {farbe <- c("dodgerblue3", "coral1")}else{farbe <- rainbow(length(gridlines))}

  grid_exist 		<- grid_exist[order(grid_exist[,1], grid_exist[,2]),]

  exchange 		<- exchange[order(exchange$plus_region,exchange$minus_region,exchange$timestep),]
  exchange_pump 	<- exchange_pump[order(exchange_pump$plus_region, exchange_pump$minus_region, exchange_pump$timestep),]
  
  max_ex 		<- max(c(exchange$capacity_used,exchange_pump$capacity_used,grid_exist[,3])) / 1000
  min_ex 		<- min(c(exchange$capacity_used,exchange_pump$capacity_used,grid_exist[,3])) / 1000

  # erstmal x-Achse Viertelstunden, y-Achse Austauschmenge, je Leitung verschiedene Farben
  # von jeder Leitung ein Vektor, also 1-2 und 2-3 
  
  #----------------------------------------------------------
  # exchange - je Verbindung ein Bild 
  #----------------------------------------------------------
if(FALSE){
  for(li in 1:(length(gridlines))){  
    # Grafikdatei oeffnen
    start <- f_start_figure(paste("exchange",gridlines[li],sep ="_"))

    plot(timevector[start_timestep:end_timestep],exchange$capacity_used[(start_timestep+timesteps*(li-1)):(timesteps*li)] / 1000, type = "l", col = farbe[li], lwd = 2, ylab = "GW", xlab = "", main = paste("exchange",gridlines[li], sep =" "), ylim = c((-grid_exist[li,3] / 1000 * 1.2),grid_exist[li,3] / 1000))
    abline(h = -grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = 0, col = "grey")
    legend("bottomleft", c(paste("exchange",gridlines[li], sep = " ")," grid capacity of this line"), col = c(farbe[li],"black"), lwd = c(3,2), lty = c(1,2), bty = "n")

    dev.off()
  }
}
  #---------------------------------------------------------------
  # exchange und exchange pump - je Verbindung ein Bild 
  #---------------------------------------------------------------

  for(li in 1:length(gridlines)){  
    # Grafikdatei oeffnen
    start <- f_start_figure(paste("exchange_pump",gridlines[li],sep ="_"))

    plot(timevector[start_timestep:end_timestep],exchange$capacity_used[(1+timesteps*(li-1)):(timesteps*li)] / 1000, type = "l", col = farbe[li], lwd = 2, ylab = "GW", xlab = "", main = paste("exchange",gridlines[li], sep =" "), ylim = c((-grid_exist[li,3] / 1000 * 1.35),grid_exist[li,3] / 1000))
    lines(timevector[start_timestep:end_timestep],exchange_pump$capacity_used[(1+timesteps*(li-1)):(timesteps*li)] / 1000, type = "l", col = farbe[li], lwd = 2, lty = 2)
    abline(h = -grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = 0, col = "grey")
    legend("bottomleft", c(paste("exchange", gridlines[li], sep = " "),"exchange after pump"," grid capacity of this line"), col = c(farbe[li],farbe[li],"black"), lwd = c(3,3,2), lty = c(1,2,2), bty = "n")

    dev.off()
  }

  #------------------------------
  # exchange pump als Dauerlinie
  #------------------------------
  #---------------------------------------------------------------
  # exchange und exchange pump - je Verbindung ein Bild 
  #---------------------------------------------------------------

  for(li in 1:length(gridlines)){  
    # Grafikdatei oeffnen
    ex_ordered 		<- sort(exchange$capacity_used[(1+timesteps*(li-1)):(timesteps*li)] / 1000, decreasing = TRUE)
    ex_pump_ordered 	<- sort(exchange_pump$capacity_used[(1+timesteps*(li-1)):(timesteps*li)] / 1000, decreasing = TRUE)
    start <- f_start_figure(paste("exchange_jahresdauerlinie",gridlines[li],sep ="_"))

    plot(1:timesteps,ex_ordered, type = "l", col = farbe[li], lwd = 2, ylab = "GW", xlab = "number of timesteps", main = paste("exchange ordered",gridlines[li], sep =" "), ylim = c((-grid_exist[li,3] / 1000 * 1.35),grid_exist[li,3] / 1000))
    lines(1:timesteps, ex_pump_ordered, type = "l", col = farbe[li], lwd = 2, lty = 2)
    abline(h = -grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = grid_exist[li,3] / 1000, lwd = 2, lty = 2)
    abline(h = 0, col = "grey")
    legend("bottomleft", c(paste("exchange", gridlines[li], sep = " "),"exchange after pump"," grid capacity of this line"), col = c(farbe[li],farbe[li],"black"), lwd = c(3,3,2), lty = c(1,2,2), bty = "n")

    dev.off()
  }


  #------------------------------------------------------------------------------------------------------------------
  # exchange mit Hintergrundbild - Jahresausnutzung der Leitung und bestimmte Stunden mit besonders hoher Auslastung
  #------------------------------------------------------------------------------------------------------------------
  
  # nur wenn die großen zeitaufwaendigen Grafiken gewuenscht sind, funktioniert bei 9 Regionen noch nicht
  if(big_figures){

    ex_pump_year 		<- numeric(length(gridlines)) 
    for(li in 1:length(gridlines)){
      ex_pump_year[li] 	<- sum(exchange_pump$capacity_used[(start_hour+timesteps*(li-1)):(timesteps*li)]) / 1000000
    }

    from 		<- ifelse(ex_pump_year > 0, grid_exist[,1] , grid_exist[,2])
    to 			<- ifelse(ex_pump_year < 0, grid_exist[,1] , grid_exist[,2])
    TWh 		<- abs(ex_pump_year)

    require(rimage) # Paket noetig zum Einlesen von jpegs
    # Hintergrundbild einlesen. Das mit _klein dahinter ist nicht so riesig.
    if(region_split == 3){pic <- read.jpeg("3regions_klein.jpeg")}
    if(region_split == 6){pic <- read.jpeg("6regions.jpeg")}

    # Grafikdatei oeffnen
    # postscript(file = paste("figure_sc",scenario_nr,"_map_exchange.eps", sep = ""))
    f_start_figure("map_exchange")

    standard <- par()
    par(mar = c(0,0,2,0)) # damit aller Platz genutzt wird
    plot(pic) # das Hintergrundbild
    
    if(region_split == 3){
      x_vector 	<- c(1050,1500,1300)
      y_vector 	<- c(3000,1250,500)
      xlabel 	<- c(1700,1850)
      ylabel 	<- c(2100,900) 
    }
    if(region_split == 6){
      x_vector <- c(850,1050,1600,900,1050,1550)
      y_vector <- c(3250,1600,1300,1050,500,500)
    }

    for(l in 1:length(TWh)){
      if(TWh[l] == 0){break}
      arrows(x_vector[from[l]],y_vector[from[l]],x_vector[to[l]],y_vector[to[l]], lwd = TWh[l] / 10, col = "red")
      text(xlabel[l], ylabel[l], as.character(paste(round(TWh[l]),"TWh", sep = " ")), col = "red", cex = 1.5)
    }

    title(main = "Yearly net transfer beween the regions")
    
    par(op)
    dev.off()
  }

  if(FALSE){
  #--------------
  # GESAMTKOSTEN
  #--------------
  
  fuel_fos 	<- c("hard_coal","gas","oil","ref","other","hydro","uran", "lignite")
  idx_fuel_fos 	<- which(elp_fuel[,3] %in% fuel_fos)
  elp_fos 	<- aggregate(elp_fuel[idx_fuel_fos,4:(region_split+3)], list(as.vector(elp_fuel[idx_fuel_fos,2])), sum)
  residual_load[residual_load < 0] <- 0

  cost_fos_q 	<- (price_exchange[,3:(region_split+2)] * elp_fos[,2:(region_split+1)]) /  1000000000
  cost_fos_b 	<- (price_start[,3:(region_split+2)] * residual_load[,3:(region_split+2)]) / 1000000000
  # Kosten des Quadrats unter der Merit Order
  # vorsicht! chp ist da noch nicht mit bei

  farbe 		<- rainbow(region_split)
  cost_cum 		<- rowSums(cost_fos_q)
  cost_cum_b  		<- rowSums(cost_fos_b)
  cost_cum_cum 		<- cumsum(cost_cum)
  cost_cum_cum_b 	<- cumsum(cost_cum_b)

  #----------------------
  # cost after exchange
  #----------------------
  # Grafikdatei oeffnen
  start <- f_start_figure("cost_after_exchange")

  plot(timevector_hour[start_hour:end_hour], cost_cum, type = "l", col = farbe[region_split], ylim = c(0,max(cost_cum,cost_cum_b)*1.2), xlab = "", ylab = "Billion Euro per hour", main = "cost after exchange")
  for(fos in region_split:2){
    cost_cum_part <- cost_cum
    cost_cum_part <- cost_cum_part - cost_fos_q[,fos]
    lines(timevector_hour[start_hour:end_hour], cost_cum_part, col = farbe[fos-1])
  }
  legend("topleft", c("all regions", paste("region 1-", c((region_split-1):2), sep = ""), "region 1"), col = farbe[region_split:1], lwd = 3, ncol = ceiling(length(gridlines)/4), bty = "n")

  dev.off()

  #-------------------------------
  # Cost after exchange cumulated
  #-------------------------------

  f_start_figure("costs_after_cumulated")

  plot(timevector_hour[start_hour:end_hour], cost_cum_cum, type = "h", col = farbe[region_split], ylim = c(0,max(cost_cum_cum, cost_cum_cum_b)*1.2), xlab = "", ylab = "Billion Euro", main = "cost after exchange cumulated")
  for(fos in region_split:2){
    cost_cum_part <- cost_cum_cum
    cost_cum_part <- cost_cum_part - cumsum(cost_fos_q[,fos])
    lines(timevector_hour[start_hour:end_hour], cost_cum_part, col = farbe[fos-1])
  }
  legend("topleft", c("all regions", paste("region 1-", c((region_split-1):2), sep = ""), "region 1"), col = c(farbe[region_split:1],farbe[1:(region_split-1)]), lwd = 3, ncol = ceiling(length(gridlines)/4), bty = "n")

  dev.off()

  #----------------------
  # cost before exchange
  #----------------------
  # Grafikdatei oeffnen
  start <- f_start_figure("cost_before_exchange")

  plot(timevector_hour[start_hour:end_hour], cost_cum_b, type = "l", col = farbe[region_split], ylim = c(0,max(cost_cum,cost_cum_b)*1.2), xlab = "", ylab = "Billion Euro per hour", main = "cost before exchange")
  for(fos in region_split:2){
    cost_cum_part <- cost_cum_b
    cost_cum_part <- cost_cum_part - cost_fos_q[,fos]
    lines(timevector_hour[start_hour:end_hour], cost_cum_part, col = farbe[fos-1])
  }
  legend("topleft", c("all regions", paste("region 1-", c((region_split-1):2), sep = ""), "region 1"), col = farbe[region_split:1], lwd = 3, ncol = ceiling(length(gridlines)/4),bty = "n")

  dev.off()

  #-------------------------------
  # Cost before exchange cumulated
  #-------------------------------

  f_start_figure("costs_before_cumulated")

  plot(timevector_hour[start_hour:end_hour], cost_cum_cum_b, type = "h", col = farbe[region_split], ylim = c(0,max(cost_cum_cum, cost_cum_cum_b)*1.2), xlab = "", ylab = "Billion Euro", main = "cost before exchange cumulated")
  for(fos in region_split:2){
    cost_cum_part <- cost_cum_cum_b
    cost_cum_part <- cost_cum_part - cumsum(cost_fos_q[,fos])
    lines(timevector_hour[start_hour:end_hour], cost_cum_part, col = farbe[fos-1])
  }
  legend("topleft", c("all regions", paste("region 1-", c((region_split-1):2), sep = ""), "region 1"), col = c(farbe[region_split],farbe[1:(region_split-1)]), lwd = 3, ncol = ceiling(length(gridlines)/4), bty = "n")

  dev.off()
  }
  #-----------------------
 if(FALSE){ # Auslastung der Pumpen - economics pump
  #-----------------------

  flh 			<- economics_pump$flh
  idx_flh_order		<- order(flh)
  flh_ordered 		<- flh[idx_flh_order]
  pump_name 		<- economics_pump$pump
  pump_name_ordered 	<- pump_name[order(flh)]
  idx_de 		<- which(pump_name_ordered < 1000)
  idx_no 		<- which(pump_name_ordered > 1000)
  flh_de 		<- flh_ordered[which(pump_name_ordered < 1000)]
  flh_no 		<- flh_ordered[which(pump_name_ordered > 1000)]

  start <- f_start_figure("pump_flh")
  hist(flh, main = "Utilisation of pumps",xlab = "Full Load Hours")
  dev.off()

  start <- f_start_figure("pump_flh_singlepumps")
  plot(idx_no,flh_no, col = "blue", ylab = "Full Load Hours", xlab = "number of pumps", pch = 19, ps = 0.9) 
  points(idx_de, flh_de, col = "red", pch = 19, ps = 0.9)  
  legend("topleft", c("in Norway","in Germany"), title = "Pump", col = c("blue","red"), pch = 19) 
  dev.off()
}
#------------------------
dbDisconnect(con_results)
#------------------------
}
rm(scenario_nr_vector) 
#------------------------
dbDisconnect(con_scenarios)
dbDisconnect(con_baltic)
#------------------------
