# Name: code_R_filling_level_tplus
# geaendert von Gesine
# 060613

# Hier wird nach dem die Produktion der Pumpen und Turbinen vom Modell bestimmt ist der neue Fuellstand der Reservoire berechnet.
# Input: Production der Turbinen und Pumpen, Zufluss der Seen
# Output: fil fuer den naechsten Zeitschritt

# Ablauf:
# Zuordnen der Daten zur Produktion im aktuellen Zeitschritt
# Berechnen des neuen Fuellstands aus der Produktion der Turbinen und Pumpen und dem Zufluss
# neuen Fuellstand in die fil Matrix schreiben

# elp von Proktionen und Turbinen
# fuer jeden See wird jeweils ausgerechnet, welches Volumen durch die Turbinen und Pumpen, jeweils oberhalb und unterhalb des Sees bewegt wird.
# fil von reservoirs

# die Produktion muss von MW in mio cbm umgerechnet werden
                                                                                           
# Die Produktion der Pumpen und Turbinen, jeweils in mio cbm umgerechnet und gruppiert nach Reservoir und Position
# Turbinen

# Turbinen - Aenderung in den oberen Reservoiren
res_per_turb_upper  <- fil_turb_up/sum_turb_up[idx_sum_up,2]
res_per_turb_lower  <- fil_turb_lo/sum_turb_lo[idx_sum_lo,2]

res_per_pump_upper  <- fil_pump_up/sum_pump_up[idx_sum_up,2]
res_per_pump_lower  <- fil_pump_lo/sum_pump_lo[idx_sum_lo,2]

u_flo_up            <- u_flo_turb[idx_up_turb]
idx_u_flo_up_NA     <- which(is.na(u_flo_up) == TRUE)
u_flo_up[idx_u_flo_up_NA] <- 0
                                               
elp_turb_up_sep     <- elp[i, idx_elp_up]  # Produktion indiziert nach turb_upper
elp_turb_fil_up     <- (elp_turb_up_sep * res_per_turb_upper * 0.001 * energy_factor / efactor_upper) 

elp_turb_fil_up     <- ifelse(elp_turb_fil_up < 0, 0, elp_turb_fil_up )

idx_NA2             <- which(is.na(elp_turb_fil_up) == TRUE)
elp_turb_fil_up[idx_NA2]    <- 0

elp_turb_up         <- aggregate(elp_turb_fil_up, list(res_upper), sum) # Es wird ein dataframe gebildet mit den Werten in der 2. Spalte.

elp_turb_up         <- elp_turb_up[idx_res_upper_un,2] # indiziert in der Reihenfolge von res

idx_NA11                 <- which(is.na(elp_turb_up) == TRUE)
elp_turb_up[idx_NA11]    <- 0

# Turbinen - Aenderung in den unteren Reservoiren
# Hier kommt unabhaengig von der Produktion auf jeden Fall der unregulierte Zufluss dazu.
elp_turb_lo_sep     <- elp [i, idx_elp_lo]
elp_turb_fil_lo     <- elp_turb_lo_sep * res_per_turb_lower * 0.001 * energy_factor / efactor_lower
min_u_flo_lo        <- u_flo_turb[idx_lo_turb]* res_per_turb_lower
idx_min_flo_NA      <- which(is.na(min_u_flo_lo) == TRUE)
min_u_flo_lo[idx_min_flo_NA] <- 0

elp_turb_fil_lo     <- elp_turb_fil_lo + min_u_flo_lo # Zusaetzlich der unregulierte Zufluss

idx_NA12                 <- which(is.na(elp_turb_fil_lo) == TRUE)
elp_turb_fil_lo[idx_NA12]    <- 0

elp_turb_lo         <- aggregate (elp_turb_fil_lo, list(res_lower), sum)

elp_turb_lo         <- elp_turb_lo[idx_res_lower_un,2]
idx_NA1                 <- which(is.na(elp_turb_lo) == TRUE)
elp_turb_lo[idx_NA1]    <- 0

# Pumpen - Aenderung in den oberen Reservoiren
elp_pump_up_sep     <- elp_pump_each[i, idx_elp_pump_up]
elp_pump_fil_up     <- elp_pump_up_sep * res_per_pump_upper * 0.001 * energy_factor / efactor_upper

idx_NA41                 <- which(is.na(elp_pump_fil_up) == TRUE)
elp_pump_fil_up[idx_NA41]    <- 0

elp_pump_up         <- aggregate(elp_pump_fil_up, list(res_upper), sum)

elp_pump_up         <- elp_pump_up[idx_res_upper_un,2]
idx_NA4                 <- which(is.na(elp_pump_up) == TRUE)
elp_pump_up[idx_NA4]    <- 0

# Pumpen - Aenderung in den unteren Reservoiren
elp_pump_lo_sep     <- elp_pump_each[i, idx_elp_pump_lo]
elp_pump_fil_lo     <- elp_pump_lo_sep * res_per_pump_lower * 0.001 * energy_factor / efactor_lower

idx_NA31                 <- which(is.na(elp_pump_fil_lo) == TRUE)
elp_pump_fil_lo[idx_NA31]    <- 0

elp_pump_lo         <- aggregate(elp_pump_fil_lo, list(res_lower), sum)

elp_pump_lo         <- elp_pump_lo[idx_res_lower_un,2]
idx_NA3                 <- which(is.na(elp_pump_lo) == TRUE)
elp_pump_lo[idx_NA3]    <- 0

# Zufluss zu den Reservoiren
flo_reg[-idx_res_de] <- res_flo[-idx_res_de] * flo[i] 
flo_reg[idx_res_de]  <- res_flo[idx_res_de] * flo_de[i]

# Zufluss aus Fluessen, die von oberhalb liegenden Reservoiren gespeist werden.
flo_river           <- (elp[i, idx_elp_turb] * 0.001 * energy_factor / efactor_upper[idx_up_turb_rev]) + u_flo_turb # Fluss in der Reihenfolge von turb_nr
flo_river           <- as.numeric(flo_river[idx_flo_river]) # Fluss in der Reihenfolge von res_nr
idx_river_NA        <- which(is.na(flo_river) == TRUE)
flo_river[idx_river_NA] <- 0

# Prouktion von Kraftwerk geht oben raus und unten rein
# Produktion von Pumpen geht unten raus und oben rein
# Zusaetzlich kommt in jedes Reservoir noch der Zufluss dazu
# Dazu der Fluss aus Kraftwerken ohne Untersee (flo_river) und Laufwasserkraftwerken (flo_river_ror)

fil_new             <- fil[i,] + elp_turb_lo + elp_pump_up - elp_turb_up - elp_pump_lo + flo_reg + flo_river + flo_river_ror[i, ]

idx_check_lower     <- which(fil_new < 0) # zur Sicherheit werden negative Fuellstaende ausgeschlossen und gleich 0 gesetzt.
fil_new[idx_check_lower] <- 0

####### 1
spil_all            <- fil_new - fil_max  
spil_all            <- ifelse (spil_all < 0, 0, spil_all)

fil_new <- fil_new - spil_all

# Das uebergelaufene Wasser fliesst in das naechst darunter liegende Reservoir
spil_new            <- spil_all[idx_spil]

idx_NA0             <- which(is.na(spil_new) == TRUE) 
spil_new[idx_NA0]     <- 0                         
spil_rest1          <- spil_all - spil_new

fil_new       <- fil_new + spil_new

####### 2
spil_all            <- fil_new - fil_max  
spil_all            <- ifelse (spil_all < 0, 0, spil_all)

fil_new <- fil_new - spil_all

# Das uebergelaufene Wasser fliesst in das naechst darunter liegende Reservoir
spil_new            <- spil_all[idx_spil]

idx_NA0             <- which(is.na(spil_new) == TRUE) 
spil_new[idx_NA0]     <- 0                         
spil_rest2          <- spil_all - spil_new

fil_new       <- fil_new + spil_new

####### 3
spil_all            <- fil_new - fil_max  
spil_all            <- ifelse (spil_all < 0, 0, spil_all)

fil_new <- fil_new - spil_all

# Das uebergelaufene Wasser fliesst in das naechst darunter liegende Reservoir
spil_new            <- spil_all[idx_spil]

idx_NA0             <- which(is.na(spil_new) == TRUE) 
spil_new[idx_NA0]     <- 0                         
spil_rest3          <- spil_all - spil_new

fil_new       <- fil_new + spil_new

####### 4
spil_all            <- fil_new - fil_max  
spil_all            <- ifelse (spil_all < 0, 0, spil_all)

fil_new <- fil_new - spil_all

# Das uebergelaufene Wasser fliesst in das naechst darunter liegende Reservoir
spil_new            <- spil_all[idx_spil]

idx_NA0             <- which(is.na(spil_new) == TRUE) 
spil_new[idx_NA0]     <- 0                         
spil_rest4          <- spil_all - spil_new

fil_new       <- fil_new + spil_new

#######
# Wenn nun noch was ueberlaeuft, muss es ungenutzt bleiben und wird in der Datenbank festgehalten.
spil_end            <- fil_new - fil_max
spil_end            <- ifelse (spil_end < 0, 0, spil_end)

spil[i]             <- sum(spil_end) + sum(spil_rest1) + sum(spil_rest2) + sum(spil_rest3) + sum(spil_rest4) 

idx_check_upper     <- which(fil_new > fil_max) # Wenn zuviel Wasser in den Reservoiren ist, muss das ungenutzt abfliessen. Der  Fuellstand wird = fil_max gesetzt.
fil_new[idx_check_upper] <- fil_max[idx_check_upper]

fil[i+1,]           <- fil_new
