# code_R_geo
# zuletzt bearbeitet von gesine
# am 070812

# in diesem Code Stueck wird die Geothermie Einspeisung je Region fuer jede Stundes des Jahres bestimmt: Ein Band, das 85,63% der installierten Leistung entspricht in jeder Stunde des Jahres

#-------------------------------------
geo_env <- function(){
  
# installierte Leistung, angenommen wird 85,63% der installierten Leistung als Band - es wird in MW gerechnet
p_geo 		<- scenario_re$geo * 0.8563 * 1000
# Da die verfuegbare Geothermie erstmal in jeder Stunde gleich ist wird der Wert 8760 mal wiederholt
geo_reg 	<- matrix(rep(p_geo, end_timestep), ncol = length(country_list), byrow = TRUE)

#-----------------------------------------------------------------------------                       

if (region_split_de > 1) {
  # Verteilung der Einspeisung auf die Regionen innerhalb Deutschlands
  geo_distribution        <- dbGetQuery(con_baltic, "SELECT capacity FROM ee_distribution WHERE technology = 'geothermal'")
  geo_distribution        <- as.numeric(as.character(unlist(geo_distribution)))
  geo_share               <- geo_distribution/sum(geo_distribution)
  geo_dpr_de              <- matrix(0, nrow = end_timestep, ncol = 21)  
  geo_dpr_de[ ,1:18]      <- geo_reg[ ,1] %*% t(geo_share)
  
  geo_reg_de <- matrix(NA, ncol = region_split_de, nrow = end_timestep)
  
  if (region_split_de < 21) {
    # die Aufteilung der dpr auf die Regionen ist in region_list gespeichert
    for(reg in 1:region_split_de){
      r <- region_list[[reg]]
      if(length(r) == 1){
        geo_reg_de[,reg] <- geo_dpr_de[,(region_list[[reg]]-100)]
      }else{
        geo_reg_de[,reg] <- rowSums(geo_dpr_de[,(region_list[[reg]]-100)])
      }
    }
  } else {
    geo_reg_de          <- geo_dpr_de
  }
  if(length(country_list)==1){
    geo_reg <- geo_reg_de
  }else{
    geo_reg                 <- cbind(geo_reg_de, geo_reg[ ,2:length(country_list)])
  }
}

return(geo_reg)
}

geo_reg <- geo_env()
