# code_R_prep_grid
# zuletzt bearbeitet von frauke
# 171012


prep_grid_env <- function(){
#------------------------------------------------------
sql_grid      <- paste("SELECT scenario_year, from_reg, to_reg, capacity_from, capacity_to FROM grid_scenario WHERE scenario_name = '",grid_scenario,"'",sep = "")
grid_data_all <- dbGetQuery(con_scenarios, sql_grid)

grid_now  <- dbGetQuery(con_baltic, "SELECT * FROM grid_circuits")

#------------------------------------------------------
# Wenn es ein Netzszenario fuer das Szenariojahr gibt, werden diese Zahlen fuer die internationalen Verbindungen genommen.

if(scenario_year %in% grid_data_all$scenario_year){

  grid_data   <- subset(grid_data_all, grid_data_all$scenario_year == scenario_year)
  
  # sortieren
  grid_data   <- grid_data[order(grid_data$from_reg,grid_data$to_reg),]
  
  # Maximum aus from und to, sollte nochmal geaendert werden
  capacity 	  <- pmax(as.numeric(as.character(grid_data$capacity_from)), as.numeric(as.character(grid_data$capacity_to)))
  
  # grid_exist
  grid_exist 	<- data.frame(cbind(grid_data$from_reg, grid_data$to_reg, capacity))
  colnames(grid_exist) 	<- c("plus_region","minus_region","capacity")
  
} else {

# Wenn nicht muessen die Netzverbindungen interpoliert werden
  
  sql_grid 	  <- paste("SELECT from_reg, to_reg, capacity_from, capacity_to FROM grid_circuits WHERE start_year < ",scenario_year, sep = "")
  grid_data 	<- dbGetQuery(con_baltic,sql_grid)

  # sortieren
  grid_data 	<- grid_data[order(grid_data$from_reg,grid_data$to_reg),]

  # Maximum aus from und to, sollte nochmal geaendert werden
  capacity 	<- pmax(as.numeric(as.character(grid_data$capacity_from)), as.numeric(as.character(grid_data$capacity_to)))

  # aggregieren
  cap_aggre 	<- aggregate(capacity, list(grid_data$from_reg, grid_data$to_reg), sum)

  # sortieren
  grid_2015 	<- cap_aggre[order(cap_aggre$Group.1,cap_aggre$Group.2),]
  
  # Spaltennamen
  colnames(grid_2015)   <- c("plus_region","minus_region","capacity")
  
  #------------------------------------------------------  
  # Die Szenario-Daten fuer 2050 auslesen
  
  sql_grid_2050   <- paste("SELECT from_reg, to_reg, capacity_from, capacity_to FROM grid_scenario WHERE scenario_year = '2050' AND scenario_name = '",grid_scenario,"'",sep = "")
  grid_data_2050  <- dbGetQuery(con_scenarios, sql_grid_2050)
  
  # sortieren
  grid_data_2050  <- grid_data_2050[order(grid_data_2050$from_reg,grid_data_2050$to_reg),]
    
  # Maximum aus from und to, sollte nochmal geaendert werden
  capacity_2050   <- pmax(as.numeric(as.character(grid_data_2050$capacity_from)), as.numeric(as.character(grid_data_2050$capacity_to)))
    
  #------------------------------------------------------  
  # zwischen status_quo und scenario_year interpolieren
  grid_regions_2015 <- paste(grid_2015$plus_region,grid_2015$minus_region, sep = "_")
  grid_regions_2050 <- paste(grid_data_2050$from_reg,grid_data_2050$to_reg, sep = "_")
  
  idx_lines     <- match(grid_regions_2050, grid_regions_2015)
  
  grid_2015     <- data.frame(cbind(grid_data_2050$from_reg, grid_data_2050$to_reg, grid_2015$capacity[idx_lines]))
  colnames(grid_2015)   <- c("plus_region","minus_region","capacity")
  
  idx_new       <- which(is.na(grid_2015$capacity))
  grid_2015$capacity[idx_new] <- 0  
  
  grid_interpol <- (scenario_year - 2015) / (2050 - 2015)
    
  grid_diff     <- capacity_2050 - grid_2015$capacity
    
  grid_year     <- grid_2015$capacity + grid_diff * grid_interpol
  
  grid_exist    <- data.frame(cbind(grid_2015$plus_region, grid_2015$minus_region, round(grid_year)))
  colnames(grid_exist)   <- c("plus_region","minus_region","capacity")
}

if (region_split_de > 1) {
  # Fuer die Verbindungen in Deutschland werden die alten Leitungen gleichmaessig erhoeht.
  
  grid_now_de <- subset(grid_now, grid_now$from_reg < 200 & grid_now$to_reg < 200)
  
  # Aus der Information Anzahl Stromkreise die Netzkapazitaet berechnen
  grid_cap_de <- grid_now_de$no_circuits * 0.7 * sqrt(3) * (as.numeric(as.character(grid_now_de$voltage))/1000) * 2720 # 2720A Formel aus DENA Studie fuer Bestandsleitungen
  
  grid_cap_aggre <- aggregate(grid_cap_de, list(grid_now_de$from_reg, grid_now_de$to_reg), sum)
  
  grid_de     <- grid_cap_aggre[,3] + grid_cap_aggre[,3] * grid_de_ext
  
  grid_exist_de <- data.frame(cbind(grid_cap_aggre[,1], grid_cap_aggre[,2], grid_de))
  colnames(grid_exist_de)   <- c("plus_region","minus_region","capacity")
  
  if (region_split_de < 21) { 
    # Wenn Deutschland in weniger als 21 Regionen aufgeteilt ist, muessen die Netzverbindungen zusammen gefasst werden.
    
    region_list_vector        <- rep(seq_along(region_list), sapply(region_list, length))
    
    from_reg_region_map       <- sapply(grid_exist_de$plus_region, function(x)   region_list_vector[which(unlist(region_list) %in% x)]) # Gibt jeweils die Region aus region_list 
    to_reg_region_map         <- sapply(grid_exist_de$minus_region, function(x) region_list_vector[which(unlist(region_list) %in% x)])
    
    grid_de_aggre_1           <- aggregate(grid_exist_de$capacity, list(from_reg_region_map, to_reg_region_map), sum)
    
    grid_de_aggre_1           <- cbind(pmin(grid_de_aggre_1[,1], grid_de_aggre_1[,2]), pmax(grid_de_aggre_1[,1], grid_de_aggre_1[,2]), grid_de_aggre_1[,3])
    
    grid_de_aggre_2           <- aggregate(grid_de_aggre_1[,3], list(grid_de_aggre_1[,1], grid_de_aggre_1[,2]), sum)
    
    idx_in_region             <- which(grid_de_aggre_2[,1] == grid_de_aggre_2[,2])
    
    grid_de_aggre_3           <- grid_de_aggre_2[-idx_in_region,]
    
    grid_exist_de             <- grid_de_aggre_3
    colnames(grid_exist_de)   <- c("plus_region","minus_region","capacity")
  }
  
  grid_exist  <- rbind(grid_exist, grid_exist_de)
  
  if (region_split_de < 21){
    plus_region_map       <- unlist( sapply(grid_exist$plus_region[which(grid_exist$plus_region<200 & grid_exist$plus_region > 100)], function(x)   region_list_vector[which(unlist(region_list) %in% x)])) # Gibt jeweils die Region aus region_list 
    
    grid_exist$plus_region[which(grid_exist$plus_region<200& grid_exist$plus_region > 100)] <- plus_region_map
    
  }

} else {
  idx_grid_de <- which(grid_exist$plus_region < 200)
  grid_exist$plus_region[idx_grid_de] <- 1
  
}

# Nur die Regionen, die auch in area enthalten sind

idx_area      <- which(grid_exist$plus_region %in% regions & grid_exist$minus_region %in% regions)

grid_exist    <- grid_exist[idx_area,]

idx_grid      <- order (grid_exist$plus_region, grid_exist$minus_region)
grid_exist    <- grid_exist[idx_grid,]
row.names(grid_exist)<-NULL

return(grid_exist)
}

grid_exist <- prep_grid_env()
