# code_R_results
# zuletzt bearbeitet von frauke
# 201012

# In diesem code-Stueck werden die Ergebnisse der Berechnung in die Datenbank geschrieben.
# Zusaetzlich werden einige Ergebnisse aggregiert gespeichert, um die Auswertung zu erleichtern.

# die Datenbankverbindung zur richtigen Ergebnis-Datenbank oeffnen
source("code_R_mysql_connection_results.R")

#-----------------------  
# Wirtschaftlichkeit ausrechnen
#----------------------- 

source('code_R_economics.R') 

# Hier werden wirtschaftliche Indikatoren fuer Kraftwerke und Netze ausgerechnet und in die DB geschrieben

# ----------------------------------
# alle Ergebnisse die quasi fertig sind und die gleiche struktur haben werden zum data.frame und so
timestep        		<- c(start_timestep:end_timestep) # TIMESTEP ist nun der Vektor alles Zeitschritte, TIMESTEPS die Anzahl

timestep_vec        <- rep(timestep, each = region_split)
db_regions          <- rep(regions, times = timesteps)

demand 			        <- c(t(demand_reg[start_timestep:end_timestep,]))
residual_load 	    <- c(t(rl_reg[start_timestep:end_timestep,]))
ee_reduction 		    <- c(t(negative_demand[start_timestep:end_timestep,]))

co2                 <- c(t(co2[start_timestep:end_timestep,]))
over_demand         <- c(t(over_demand[start_timestep:end_timestep,]))
price_exchange      <- c(t(price_exchange[start_timestep:end_timestep,]))
price_start         <- c(t(price_start[start_timestep:end_timestep,]))
spil                <- spil[start_timestep:end_timestep]

wind_on_reg         <- c(t(wind_on_reg[start_timestep:end_timestep,]))
wind_off_reg        <- c(t(wind_off_reg[start_timestep:end_timestep,]))
solar_reg           <- c(t(solar_reg[start_timestep:end_timestep,]))
bio_reg             <- c(t(bio_reg[start_timestep:end_timestep,]))
ror_reg             <- c(t(ror_reg[start_timestep:end_timestep,]))
geo_reg             <- c(t(geo_reg[start_timestep:end_timestep,]))
elp_reg_fossil      <- c(t(elp_reg_fossil[((start_timestep-1)*length(fuel_standard)+1):(end_timestep*length(fuel_standard)),]))

elp_other_turb <- c(t(elp_stor_other_turb[start_timestep:end_timestep,]))
elp_other_pump <- c(t(elp_stor_other_pump[start_timestep:end_timestep,]))

elp_pump 		        <- c(t(elp_pump[start_timestep:end_timestep,]))
elp_pump_ex 		    <- c(t(elp_pump_ex[start_timestep:end_timestep,]))

# ee_reduction_pump_ex 	<- negative_demand_pump_ex wird anders berechnet

exchange_diff 		  <- exchange_combined
exchange_diff[,3] 	<- exchange_pump_combined[,3] - exchange_combined[,3] 
# exchange_diff ist das was sich im Transport des Stroms aendert im pump_exchange Schritt, noetig um die zusaetzliche Minderung der Abregelung (weniger ee_reduction) ausrechnen zu koennen

# ich brauch ne Matrix mit Spalten so viele wie Regionen und Zeilen so viele wie timesteps
 ee_red_red 		<- matrix(ncol = region_split, nrow = timesteps)
l   <- length(new$grid[,1])
if (l > 1){
  for(qu in 1:timesteps){
    g 	<- exchange_diff[((qu-1)*l+1):(qu*l),]
    for(re in 1:region_split){
      idx_plus 	<- which(g[,1] == re)
      idx_minus 	<- which(g[,2] == re)
      plus 	<- ifelse(length(idx_plus) == 0,0,sum(g[idx_plus,3]))
      minus 	<- ifelse(length(idx_minus) == 0 ,0,sum(g[idx_minus,3]))
      ee_red_red[qu,re] <- plus - minus
    }
  }

} else {
  for(qu in 1:timesteps){
    g   <- exchange_diff[((qu-1)*l+1):(qu*l),]
    for(re in 1:region_split){
      idx_plus 	<- which(g[1] == re)
      idx_minus 	<- which(g[2] == re)
      plus 	<- ifelse(length(idx_plus) == 0,0,sum(g[idx_plus,3]))
      minus 	<- ifelse(length(idx_minus) == 0 ,0,sum(g[idx_minus,3]))
      ee_red_red[qu,re] <- plus - minus
    }
  }
}
# ueberall da wo ee_red_red negativ ist fliesst was hin, das ist fuer ee_reduction uninteressant, deshalb 0 
ee_red_red[ee_red_red < 0] 	<- 0
ee_reduction_pump_ex <- c(t(negative_demand_pump + ee_red_red))

ee_reduction_pump    <- c(t(negative_demand_pump[start_timestep:end_timestep,]))

table_names_1         <- c("co2","demand", "ee_reduction", "ee_reduction_pump", "ee_reduction_pump_ex","elp_pump", "elp_pump_ex","over_demand", "price_exchange", "price_start", "residual_load", "elp_other_pump", "elp_other_turb")

for(tab_name in table_names_1){
  a <- parse(text = paste(tab_name,"_data <- data.frame(cbind(scenario_nr, timestep_vec, db_regions,",tab_name,"))",sep =""))
  eval(a)
  a <- parse(text = paste("colnames(",tab_name,"_data) <- c('scenario_nr', 'timestep', 'region', '",tab_name,"')" ,sep =""))
  eval(a)
}

# spil vorbereiten
spil_data 			    <- data.frame(cbind(scenario_nr, timestep, spil))
colnames(spil_data)<- c("scenario_nr", "timestep", "spil")

# exchange_data vorbereiten
exchange_data         <- data.frame(cbind(scenario_nr, rep(timestep, each=length(new$grid[,1])), exchange_combined))

colnames(exchange_data) <- c("scenario_nr", "timestep", "plus_region", "minus_region", "capacity_used" )

exchange_pump_data <- data.frame(cbind(scenario_nr, rep(timestep, each=length(new$grid[,1])), exchange_pump_combined))

colnames(exchange_pump_data)<- c("scenario_nr", "timestep", "plus_region", "minus_region", "capacity_used" )

# die Namen der Tabellen die jetzt in die Datenbank geschrieben werden sollen
table_names_1 		    <- c(table_names_1,"spil", "exchange", "exchange_pump")
# Und die Bezeichnungen wo die Daten stecken in der gleichen Reihenfolge
table_data_1          <- paste(table_names_1,"data",sep = "_")

# Und der erste Schwung Tabellen in die Datenbank
for(tab in 1:length(table_names_1)){
  dbWriteTable(con_results, table_names_1[tab], get(table_data_1[tab]), row.names = FALSE, append = TRUE)
}

# Daten loeschen
rm(co2_data, exchange_data,exchange_pump_data,  spil_data, spil, ee_reduction, negative_demand, ee_reduction_pump, negative_demand_pump, demand, demand_reg, residual_load, elp_pump, elp_pump_ex)

rm(exchange_combined, exchange_pump_combined, rl_reg)

# ----------------------------------
# elp_fuel vorbereiten
# chp ist momentan ausgeschaltet.
elp_reg_ee            <- c(wind_on_reg, wind_off_reg, solar_reg, bio_reg, ror_reg, geo_reg, u_flo_reg)

fuels                 <- c("wind_onshore", "wind_offshore", "solar", "biomass", "run_of_river", "geothermal", "hydro_ureg", "lignite", "hard_coal", "gas", "oil", "other_stor", "refuse", "uran", "hydro")
elp_reg_fuel          <- c(elp_reg_ee, elp_reg_fossil)
regions_fuel          <- rep(regions, times = timesteps * length(fuels))
timestep_fuel         <- rep(timestep, each = region_split, times = length(fuels))
fuels_db              <- rep(fuels, each = region_split * timesteps)

elp_fuel_data         <- data.frame(cbind(scenario_nr, timestep_fuel, fuels_db, regions_fuel, elp_reg_fuel))
colnames(elp_fuel_data) 	<- c("scenario_nr","timestep","fuel", "region", "elp_fuel")

dbWriteTable(con_results, "elp_fuel", elp_fuel_data, row.names = FALSE, append = TRUE)

#------------------------------------
# Einzelpumpen
if (length(pump_save) > 0) {
  idx_pump_single     <- match(pump_save, pump_standard)
  elp_pump_single     <- elp_pump_each[1:end_timestep,idx_pump_single]
  elp_pump_single     <- c(t(elp_pump_single))
  timestep_single_pump <- rep(timestep, each = length(pump_save))
  single_pump_nr      <- rep(pump_save, times = end_timestep)
  
  single_pump_data    <- data.frame(cbind(scenario_nr, timestep_single_pump, single_pump_nr, elp_pump_single ))
  colnames(single_pump_data) <- c("scenario_nr", "timestep", "pump", "elp_pump")
  
  dbWriteTable(con_results, "elp_single_pump", single_pump_data, row.names = FALSE, append = TRUE)
}

#------------------------------------
# Einzel(wasser)kraftwerke
if (length(pp_save) > 0) {
  idx_pp_single     <- match(pp_save, unit_standard)
  elp_pp_single     <- elp[1:end_timestep,idx_pp_single]
  elp_pp_single     <- c(t(elp_pp_single))
  timestep_single_pp <- rep(timestep, each = length(pp_save))
  single_pp_nr      <- rep(pp_save, times = end_timestep)
  
  single_pp_data    <- data.frame(cbind(scenario_nr, timestep_single_pp, single_pp_nr, elp_pp_single ))
  colnames(single_pp_data) <- c("scenario_nr", "timestep", "pp_nr", "elp")
  
  dbWriteTable(con_results, "elp_single_pp", single_pp_data, row.names = FALSE, append = TRUE)
  }

#------------------------------------

rm(elp_reg_ee, elp, elp_pump_each, elp_fuel_data, elp_reg_fuel, bio_reg, wind_off_reg,ror_reg, solar_reg, wind_on_reg)#, chp_reg)

#------------------------------------
# Indikatoren fuer Wasserreservoire
fil_summary    <- apply(fil, 2, summary)
fil_min        <- fil_summary[1,]/fil_max
fil_max_level  <- fil_summary[6,]/fil_max
fil_mean       <- fil_summary[4,]/fil_max
fil_end        <- fil[timesteps+1,]/fil_max
fil_max_delta  <- apply((apply(fil, 2, diff)), 2, max)

fil_indicator  <- data.frame(cbind(scenario_nr, res_nr, fil_max_level, fil_min, fil_mean, fil_end, fil_max_delta))
colnames(fil_indicator) <- c("scenario_nr", "res_nr", "max", "min", "mean", "end", "max_delta")

dbWriteTable(con_results, "filling_level_indicator", fil_indicator, row.names = FALSE, append = TRUE)                             
rm(fil_summary, fil_max_delta)

# Aggregierte Fuellstandskurven
# Fuellstaende in TWh umrechnen
fil_twh <- t(apply(fil, 1 , function(x) x * total_efactor * 0.001))

# Reservoirefuellstaende werden nach Laendern getrennt
fil_reg         <- matrix(0, nrow = end_timestep + 1, ncol = length(country_list))
fil_reg_energy  <- matrix(0, nrow = end_timestep + 1, ncol = length(country_list))

for (r in country_list){
  idx_r         <- which(country_list == r)
  idx_res_reg   <- which(res_nr > r*1000 & res_nr< (r+1)*1000)
  fil_reg[,idx_r]   <- rowSums(fil[,idx_res_reg])
  fil_reg_energy[,idx_r] <- rowSums(fil_twh[,idx_res_reg])
} 

fil_reg         <- c(t(fil_reg[start_timestep:(end_timestep+1),]))
fil_reg_energy  <- c(t(fil_reg_energy[start_timestep:(end_timestep+1),]))

# Die Reservoire, die einzeln gespeichert werden sollen, werden ausgewaehlt
if (length(res_save) > 0) {
  idx_single        <- match(res_save, res_nr)
  fil_single        <- fil[start_timestep:(end_timestep+1),idx_single]
  fil_single_energy <- fil_twh[start_timestep:(end_timestep+1),idx_single]
  fil_single        <- c(t(fil_single))
  fil_single_energy <- c(t(fil_single_energy))
}

#rm(fil, fil_twh)

# data.frame erstellen
timestep_fil      <- c(start_timestep:(end_timestep+1))
timestep_fil_vec  <- rep(timestep_fil, each = length(country_list))
db_regions_fil    <- rep(country_list , times = timesteps+1)
 
filling_level_data  <- data.frame(cbind(scenario_nr, timestep_fil_vec, db_regions_fil, fil_reg, fil_reg_energy))
colnames(filling_level_data)  <- c("scenario_nr", "timestep", "region", "filling_level", "filling_level_energy")

dbWriteTable(con_results, "filling_level", filling_level_data, row.names = FALSE, append = TRUE)

# Fuer die Einzelreservoire
if (length(res_save) > 0) {
  timestep_single_fil <- rep(timestep_fil, each = length(res_save))
  db_res_save         <- rep(res_save, times = timesteps+1)
  
  filling_level_single_data <- data.frame(cbind(scenario_nr, timestep_single_fil, db_res_save, fil_single, fil_single_energy))
  colnames(filling_level_single_data) <- c("scenario_nr", "timestep", "reservoir", "filling_level", "filling_level_energy")
  
  dbWriteTable(con_results, "filling_level_single_res", filling_level_single_data, row.names = FALSE, append = TRUE)
}

fil_other           <- c(t(fil_other[start_timestep:(end_timestep),]))
fil_other_data      <- data.frame(cbind(scenario_nr, timestep_vec, db_regions, fil_other))
colnames(fil_other_data)  <- c("scenario_nr", "timestep", "region", "filling_level_other")

dbWriteTable(con_results, "filling_level_other", fil_other_data, row.names = FALSE, append = TRUE)

# ---------------------------------

# Am Ende des Szenarios wird in der Szenario-Tabelle bestaetigt, dass das Szenario gerechnet wurde

dbDisconnect(con_scenarios)

source('code_R_mysql_connection.R')

sql_end 	<- paste("UPDATE scenario_nr SET calculated = '",when,"' WHERE scenario_nr = '",scenario_nr,"' ", sep="")
dbSendQuery(con_scenarios, sql_end) 

# Datenbankverbindung zur results-Datenbank schliessen
dbDisconnect(con_results)

