# code_R_ror
# zuletzt bearbeitet von frauke
# am 090612

# in diesem Code Stueck wird die Einspeisung aus run of river je Region fuer jede Stundes des Jahres bestimmt: Bisher ein Band, das 60,5% der installierten Leistung entspricht in jeder Stunde des Jahres

#-------------------------------------
# Die Volllaststunden des Jahres haengen vom Wetterjahr ab
# if (weather_year == 2010){uti <- 0.45 } 
# if (weather_year == 1998){uti <- 0.65 } 
# if (weather_year == 2003){
  uti <- 0.55

# installierte Leistung, angenommen wird 60,5%% der installierten Leistung als Band - es wird in MW gerechnet
p_ror 		<- scenario_re$run_of_river * 1000

p_ror_de  <- scenario_re$run_of_river[which(scenario_re$country_id == 1)]*1000

# Da die verfuegbare Laufwasser erstmal in jeder Stunde gleich ist wird der Wert 8760 mal wiederholt
ror_reg 	<- matrix(rep(p_ror * uti, end_timestep), ncol = length(country_list), byrow = TRUE)

#-----------------------------------------------------------------------------
# Laufwasser in Norwegen
# Gesamtproduktion der Laufwasserkraftwerke
sql_ror_no          <- dbGetQuery(con_baltic, "SELECT Pinst, total_flow, efactor * total_flow AS eflow, flo_river_ror FROM ee_ror WHERE dpr = '900' ORDER BY ror_nr")
ror_pinst_no        <- as.numeric(as.character(sql_ror_no$Pinst))
ror_eflo            <- as.numeric(as.character(sql_ror_no$eflow)) * 1000  / energy_factor # Hier werden GWh in MW umgerechnet
ror_flo             <- as.numeric(as.character(sql_ror_no$total_flow))
flo_river_ror_nr    <- as.numeric(as.character(sql_ror_no$flo_river_ror))

# Hier bestimmt die Auswahl des Wasserjahres (normal, low) das Wasserjahr

# if (weather_year == 2010){flo_year <- 1969 } 
# if (weather_year == 1998){
# flo_year <- 1990 
# if (weather_year == 2003){
flo_year <- 1979

# Die Zuflusskurve bestimmt die Einspeisekurve
sql_flo             <- paste("SELECT flo FROM storage_flow_",time_unit," WHERE year = '",flo_year,"' AND level_meter = 'NO' ORDER BY ",time_unit," ", sep="")
flo                 <- dbGetQuery (con_baltic, sql_flo)
flo                 <- as.numeric(as.character(unlist(flo)))

ror_flo_res_nr      <- aggregate(ror_flo, by = list(flo_river_ror_nr), sum)
idx_flo_res         <- which(ror_flo_res_nr[,1]> 0)

ror_res_nr          <- ror_flo_res_nr[idx_flo_res,1]

ror_flo_no          <- t(apply(t(flo), 2, function(x) ror_flo_res_nr[idx_flo_res,2] * x))

ror_no              <- apply(t(flo), 2, function(x) (pmin(ror_pinst_no, ror_eflo * x)))
ror_no              <- t(ror_no)
  
if (area != "de"){  
  
  ror_no_sum          <- rowSums(ror_no)
  
  idx_no              <- which (country_list == 9)
  
  ror_no_all          <- ror_no_sum + ror_no_sum * p_ror[idx_no]/sum(ror_pinst_no) # Hier wird noch der Ausbau von Laufwasser in Norwegen beruecksichtigt.
  
  ror_reg[,idx_no]    <- ror_no_all[1:end_timestep]

}
  
#-----------------------------------------------------------------------------
# Laufwasser in Deutschland
# Die Laufwasserkurve in Deutschland basiert auf den Pegelmessungen

# Die Laufwasserkraftwerke einlesen
ror_pp_de             <- dbGetQuery(con_baltic, "SELECT ror_nr, pinst, dpr, level_meter FROM ee_ror WHERE dpr < 200 ORDER BY ror_nr")
ror_pp                <- as.numeric(as.character(unlist(ror_pp_de$ror_nr)))
ror_pinst             <- as.numeric(as.character(unlist(ror_pp_de$pinst)))
ror_level             <- as.numeric(as.character(unlist(ror_pp_de$level_meter)))
ror_dpr               <- as.numeric(as.character(unlist(ror_pp_de$dpr)))

ror_data              <- data.frame(cbind(ror_pp, ror_pinst, ror_level, ror_dpr))

ror_dpr_list <-       vector("list", 21)

for (dpr in 1:21) {
  
  ror_dpr_list[[dpr]] <- subset(ror_data, ror_data$ror_dpr == dpr + 100)
    }

# Pegelmessdaten einlesen
sql_level_data        <- paste("SELECT level_meter, flo FROM storage_flow_",time_unit," WHERE level_meter != 'NO' ORDER BY level_meter, ",time_unit," ", sep = "")
level_data            <- dbGetQuery(con_baltic, sql_level_data)
level_flo             <- matrix(c(as.numeric(as.character(unlist(level_data$flo)))), ncol = 40, byrow = FALSE)

mean_level       <- apply(level_flo, 2, mean)                              
max_level        <- apply(level_flo, 2, max)

# ---------- Jetzt wird Fluss in Leistung umgerechnet.
pinst_level <- matrix(ncol = 21, nrow = 40)
ror_dpr_de  <- matrix(0, nrow = (8760/energy_factor), ncol = 21)
level_nr    <- c(1:40)

for (dpr in 1:18) {
  pinst_level_dpr             <- aggregate(ror_dpr_list[[dpr]]$ror_pinst, list(ror_dpr_list[[dpr]]$ror_level), sum)
  idx_level                   <- match(level_nr, pinst_level_dpr[,1])
  pinst_level[,dpr]           <- c(pinst_level_dpr[idx_level,2])
  pinst_level[which(is.na(pinst_level[,dpr])),dpr] <- 0
  
  ror_dpr_level   <- t(t(level_flo) * (((pinst_level[,dpr] * uti) - pinst_level[,dpr])/(mean_level - max_level)) + pinst_level[,dpr]  - (( (pinst_level[,dpr] * uti) - pinst_level[,dpr] )/(mean_level- max_level))* max_level)
  
  ror_dpr_de[,dpr] <- rowSums(ror_dpr_level)
  
}

ror_dpr_de   <- ror_dpr_de[1:end_timestep, ]

ror_change   <- p_ror_de/sum(ror_pinst)

ror_dpr_de   <- ror_dpr_de * ror_change

#-----------------------------------------------------------------------------                             

ror_reg_de <- matrix(NA, ncol = region_split_de, nrow = end_timestep)

if (region_split_de < 21) {
  # die Aufteilung der dpr auf die Regionen ist in region_list gespeichert
  for(reg in 1:region_split_de){
    r <- region_list[[reg]]
    if(length(r) == 1){
      ror_reg_de[,reg] <- ror_dpr_de[,(region_list[[reg]]-100)]
    }else{
      ror_reg_de[,reg] <- rowSums(ror_dpr_de[,(region_list[[reg]]-100)])
    }
  }
  
} else {
  
  ror_reg_de          <- ror_dpr_de
  
}

if(length(country_list)==1){
  ror_reg <- ror_reg_de
  }else{
  ror_reg <- cbind(ror_reg_de, ror_reg[ ,2:length(country_list)])
  }
