# code_R_scenario_loop
# zuletzt bearbeitet von frauke
# 051012

# wird aufgerufen von: code_R_start
# ruft auf: code_R_mysql_connection / code_R_marginal_function / code_R_prep_regions / code_R_RL / code_R_bmo / code_R_prep_storage / code_R_supply

# Schleife der scenario_nr . Datenbankverbindung wird geoeffnet, Zeitmesssung initialisiert, scenario_parameter ausgelesen, re_scenario und Volllaststunden ausgelesen und vorbereitet, marginal_function initialisiert, die Regionen-Liste je enstprechend dem gewaehlten region_split vorbereitet, dann die eigentliche Berechnung aufgerufen, danach Zeitmessungen erfassen und teilweise den Workspace leeren, am Schluss die Datenbankverbindung geschlossen.


if(system_software == "windows"){
  memory.limit(size = 4095) # dann gehts schneller! mehr geht allerdings nicht.
}
when  <- Sys.Date()

scn 			<- length(scenario_nr_vector) # wie viele Szenarien in dieser loop gerechnet werden

#-----------------------------
t_1 		<- Sys.time() # Stoppuhr
time_3 		<- numeric(scn) # Zeitaufzeichnung initialisieren
time_5_m 	<- numeric(scn)
time_7_m 	<- numeric(scn)
time_9_m 	<- numeric(scn)
scl 		<- 0
#----------------------------

for (scenario_loop in scenario_nr_vector){
  
  open_cons <- dbListConnections(MySQL())
  for(open_con in open_cons) dbDisconnect(open_con)
  source("code_R_mysql_connection.R")
  
  t_3 		<- Sys.time() # Stoppuhr
  scl 		<- scl + 1 # um zu wissen in der wie vielten Runde ich bin 
  sql_scenario 	<- paste("SELECT * FROM scenario_nr WHERE scenario_nr = '",scenario_loop,"'", sep="")
  scenario_parameter 	<- dbGetQuery(con_scenarios, sql_scenario) # Parameter fuer die gewaehlte scenario_nr auslesen
  
  if(length(scenario_parameter) == 0){ # wenn diese scenario_nr nicht in der Tabelle scenario_nr definiert ist Fehlermeldung
    stop(paste("no scenario parameters for chosen scenario_nr",scenario_nr_vector[scenario_loop],"defined",sep = " "))
  }

  parameter_names 	<- colnames(scenario_parameter) # ein Vektor der Namen der Parameter

  for(para_name in parameter_names[c(1:3,6, 10:11,13:22,25:26)]){ # jeder Paramter als eigene Variable (zahlen)
    a <- parse(text = paste(para_name," <- as.numeric(scenario_parameter$",para_name,")", sep = ""))
    eval(a)
  }
  for(para_name in parameter_names[-c(1:3,6, 10:11,13:22,25:26)]){ # jeder Paramter als eigene Variable (woerter)
    a <- parse(text = paste(para_name," <- scenario_parameter$",para_name, sep = ""))
    eval(a)
  }

  timesteps 		<- end_timestep - start_timestep + 1
  if (time_unit == "hour")    {energy_factor <- 1} # Umrechnungsfaktor von Leistung zu Energie, MW -> MWh
  if (time_unit == "quarter") {energy_factor <- 0.25} # Umrechnungsfaktor von Leistung zu Energie, MW -> MWh

  #-------------------------------------------------------------
  # REGIONEN VORBEREITEN
  source('code_R_prep_regions.R')
  
  #-----------------------
  
  # das re_scenario auslesen, installierte Leistung des gewaehlten RE_scenario auslesen
  sql_re_scenario 	<- paste("SELECT * FROM re_scenario WHERE scenario_name = '",re_scenario,"'", sep="")
  scenario_re 		  <- dbGetQuery(con_scenarios, sql_re_scenario)
  scenario_re       <- subset(scenario_re, scenario_re$country_id %in% country_list)
  
  
  sc_y 			        <- scenario_year # nur noetig weil sonst scenario_year doppelt vorkommt in der uebernaechsten Zeile
  
  if(scenario_year %in% scenario_re$scenario_year){
    scenario_re 	  <- subset(scenario_re, scenario_re$scenario_year == sc_y)
  
  }else{ # falls der Jahreswert fuer das gewuenschte Jahr nicht da ist, wird interpoliert fuer die inst. Leistungen
    
    available_years 	<- scenario_re$scenario_year
    order_years 	    <- order(c(available_years, scenario_year))
    idx 		          <- which(order_years == length(available_years) + 1)
    inter_years 	    <- c(scenario_re$scenario_year[c(idx-1,idx)])
    re_part 		      <- subset(scenario_re, scenario_year %in% inter_years)
    year_distance 	  <- inter_years[2] - inter_years[1]
    scenario_re[,2] 	<- scenario_year
    
    scenario_re[,4:9] <- round(re_part[1:length(country_list),4:9] + ((re_part[(length(country_list+1)):(2*length(country_list)),4:9] - re_part[(1:length(country_list)),4:9]) / year_distance) * (scenario_year - re_part$scenario_year[1]), digits = 2)
    scenario_re 	    <- scenario_re[1:length(country_list),]
  }

  
  #---------------------------------------------------
  # PARAMETER-BESTIMMUNG zuende, jetzt wird gerechnet
  #---------------------------------------------------
  #-----------------------  
  # FUNKTIONEN DEFINIEREN
  #----------------------- 
  source('R_functions/code_R_marginal_function') 
  # hier wird die Funktionen definiert die man fuer jede Grenzkraftwerk-Operation braucht: f_marginal_idx(d,s,cm)
  
  # Hier werden die Funktionen fuer den jeweiligen Algorithmus eingelesen.
  if(algorithmus == "SA")     {source('R_functions/code_R_function_exchange_SA')}
  if(algorithmus == "random") {source('R_functions/code_R_function_exchange_random')}
  
  # Weitere Funktionen, die beim  Austausch benutzt werden
  source('R_functions/code_R_function_grid_loss')
  source('R_functions/code_R_function_marginal_costs')
  source('R_functions/code_R_function_capacity_grid')
  source('R_functions/code_R_function_exchange_pump')
  
  #---------------------
  source('code_R_prep_storage.R')
  # RESIDUALLAST
  source('code_R_rl.R') # nun gibt es RL_dpr
  #----------------------------------------

  # BASIC MERIT ORDER
  source('code_R_bmo.R') # nun gibt es pp_data, alle Werte nach Grenzkosten je Region sortiert

  #----------------------------------------

  # STORAGE VORBEREITEN
  # Zufluss aus Laufwasserkraftwerken in Reservoire
  idx_flo_river_ror   <- match(res_nr, ror_res_nr)
  
  flo_river_ror       <- ror_flo_no[ , idx_flo_river_ror]
  idx_river_ror_NA    <- which(is.na(flo_river_ror) == TRUE, arr.ind=TRUE)
  flo_river_ror[idx_river_ror_NA] <- 0
  
  rm(idx_river_ror_NA)
  rm(ror_flo_no)
  
  #----------------------------------------

  # DIE RESTLICHE LAST DECKEN // AUSTAUSCHEN
  source('code_R_supply.R', echo = TRUE)

  #----------------------------------
  # ZEITMESSUNGEN ENDE / AUZEICHNUNG
  #----------------------------------
  t_4 		 			<- Sys.time()
  idx_scenario_loop 			<- which(scenario_nr_vector == scenario_loop)
  time_3[idx_scenario_loop] 		<- difftime(t_4, t_3, unit = c("secs"))
  if(scl > 1){
    time_5_m 			<- cbind(time_5_m, time_5)
    time_7_m 			<- cbind(time_7_m, time_7)
    time_9_m  			<- cbind(time_9_m, time_9)
  }else{
    time_5_m 	<- time_5
    time_7_m 	<- time_7
    time_9_m 	<- time_9
  }

  #---------------------
  # VARIABLEN AUFRAEUMEN fuer die naechste Schleifenrunde, also die naechste scenario_nr
  #---------------------
  keep <- c("scenario_nr",
            "algorithmus",
            "who",
            "supply_code_start",
            "scenario_loop",
            "scenario_nr_vector",
            "when",
            "t_1",
            "time_3",
            "time_5_m",
            "time_7_m",
            "time_9_m",
            "scl",
            "make_figures",
            "results_name",
            "con",
            "con_baltic",
            "con_scenarios",
            "pfad",
            "pp_save",
            "pump_save",
            "res_save")
  all_variables <- ls()
  idx_throw <- all_variables %in% keep
 # rm(list = all_variables[!idx_throw])

}

t_2 		<- Sys.time()
time_1 		<- difftime(t_2, t_1, unit = c("secs"))

#-------------------------------
# DATENBANKVERBINDUNG SCHLIESSEN
#-------------------------------
dbDisconnect(con_baltic)
dbDisconnect(con_scenarios)

