# Name code_R_supply
# geaendert von gesine
# 151112

# in diesem Code-Stueck wird die Residuallast rl_reg zusammengebracht mit bmo und filling_level, die Grenzkraftwerke und der Pumpeneinsatz werden bestimmt

#--------------------------

# input
#* rl_reg aus code_R_rl
#* pp_data (unit / Pinst / Cmar / pp_dpr) aus code_R_bmo und
#* pp_turb (turb / bid_turb / Cmar_turb / turb_dpr) aus code_R_filling_level
#* bid_pump aus code_R_filling_level

#--------
# ABLAUF
#--------
# zuerst werden diverse Vektoren initialisiert zum Speichern von Preisen / Netzauslastung / Kraftwerkseinsatz / Reduktion von EE-Einspeisung / nicht erfuellbare Nachfrage. Dann wird code_R_marginal_function aufgerufen, darin werden die Funktionen zum Finden des Grenzkraftwerkes initialisiert.  Ausserdem wird aus der Datenbank ausgelesen wie viele Stromkreise es je zwischen den Regionen gibt und berechnet wie viel MW durch jede Verbindung durchpasst.  Das wird fuer das ganze Jahr bereits vorab gemacht
# Dann beginnt die Viertelstunden-Zeitschleife [i]. code_R_filling level wird aufgerufen und bestimmt fuer die Viertelstunde wie die Turbinen und Pumpen anbieten. Dann wird code_R_bmo_quarter aufgerufen, falls ein Wintermonat ist (also i entsprechend kleinergleich 8640 oder groesser 26208) dann fallen noch die chp-Kraftwerke deren Pinst kleiner als die gewaehlte chp_size ist raus aus der bmo. pp_data und turb_data wird in pp_turb_data mit den Spalten unit / Pinst / Cmar / pp_dpr vereint
# Dann beginnt die Regionen Schleife [r]. Fuer jede Region wird nach Cmar das ganze pp_turb_data sortiert.

  #--------------------------------------------------
  # Der pp_data data.frame ist die Vorlage fuer die bmo, fuer jede Region soll es nun einen Abschnitt geben 
  # der nach Cmar innerhalb der Region sortiert ist.
  #--------------------------------------------------

# Die Zeit wird gemessen fuer:
# gesamter supply-code außer Ergebnisse in Datenbank schreiben
# Regionenschleife zum Bestimmen der bmo in jedem Zeitschritt - Ergebnis ist ein Vektor
# Austauschschleife gesamt, aber als Vektor fuer jeden Zeitschritt
# Austauschschleife 
# Fuellstandscode 1
# Fuellstandscode 2

#-------------------
# INITIALISIERUNGEN
#-------------------
unit_standard <- c(pp_data$pp_nr, turb$turb_nr, biomass_nr, stor_oth_nr) # Standardreihenfolge aller Produktionsanlagen im dispatch, in dieser Reihenfolge stehen sie in der elp Matrix

unit_standard_pinst <- c(pp_data$pinst, turb$turb_pinst, biomass_power, stor_pot_oth)
unit_standard_reg   <- c(pp_data$reg, turb$turb_reg, bio_regions, other_regions)

unit_standard_data <- data.frame(cbind(unit_standard, unit_standard_pinst, unit_standard_reg))
colnames(unit_standard_data) <- c("pp_nr", "pinst", "reg")

pump_standard <- c(pump$pump_nr, stor_oth_nr)

idx_elp_up        <- match(stor_upper, unit_standard)
idx_elp_lo        <- match(stor_lower, unit_standard)
idx_elp_pump_up   <- match(stor_upper, pump_standard)
idx_elp_pump_lo   <- match(stor_lower, pump_standard)

idx_elp_turb      <- match(turb$turb_nr, unit_standard)

idx_bio_elp 		  <- match(biomass_nr, unit_standard)
idx_other_turb 		<- match(stor_oth_nr, unit_standard)
idx_other_pump 		<- match(stor_oth_nr, pump_standard)

price_start 		<- matrix(ncol = region_split, nrow = end_timestep) # Preis-Matrix / Zeitschritte in Zeilen // Regionen in Spalten  - vor dem Austausch
price_exchange 		<- matrix(ncol = region_split, nrow = end_timestep) # Preis-Matrix / Zeitschritte in Zeilen // Regionen in Spalten  - nach dem Austausch

rl_exchange   		<- matrix(ncol = region_split, nrow = end_timestep) # Residuallast pro Region nach dem ersten Austauschschritt

co2 			<- matrix(ncol = region_split, nrow = end_timestep) # co2-Matrix

exchange_combined     	<- numeric(0)
exchange_pump_combined 	<- numeric(0)

elp_pump 		<- matrix(ncol = region_split, nrow = end_timestep)  # die gesamte Stromnachfrage der Pumpen
elp_pump_ex 		<- matrix(ncol = region_split, nrow = end_timestep) # Stromnachfrage der Pumpen nach dem 2.Austausch
idx_mar_pump 		<- numeric(region_split)

negative_demand 	<- matrix(ncol = region_split, nrow = end_timestep) # vor dem Pumpeneinsatz
negative_demand_pump 	<- matrix(ncol = region_split, nrow = end_timestep) # nach dem Pumpeneinsatz
negative_demand_pump_ex <- matrix(ncol = region_split, nrow = end_timestep) # nach dem Austausch des Ueberschussstroms
over_demand 		<- matrix(ncol = region_split, nrow = end_timestep)

elp 			<- matrix(0, ncol = length(unit_standard), nrow = end_timestep)
colnames(elp) 		<- unit_standard
fuel_standard 		<- c("lignite","hard_coal", "gas", "oil", "other_stor", "refuse", "uran", "hydro")
fuel_unit_list 		<- vector("list",length(fuel_standard))
fuel_unit_idx_list 	<- vector("list",length(fuel_standard))

for(fu in 1:(length(fuel_standard)-1)){
  fuel_unit_list[[fu]] 		<- as.numeric(unlist(subset(pp_data, fuel == fuel_standard[fu],select = pp_nr)))
  fuel_unit_idx_list[[fu]] 	<- match(fuel_unit_list[[fu]],unit_standard) 
}
fuel_unit_list[[8]] 		<- turb$turb_nr
fuel_unit_idx_list[[8]] 	<- match(fuel_unit_list[[8]], unit_standard)
fuel_unit_list[[5]]     <- stor_oth_nr
fuel_unit_idx_list[[5]] <- match(fuel_unit_list[[5]], unit_standard)

elp_reg_fossil 			<- matrix(0, ncol = region_split, nrow = (end_timestep) * length(fuel_standard))
rownames(elp_reg_fossil) 	<- c(rep(fuel_standard, each = (end_timestep)))
elp_pump_each		<- matrix(0, ncol = length(pump_standard), nrow = end_timestep)

#-----------------------
# NETZ-MATRIX BESTIMMEN
#-----------------------

source('code_R_prep_grid.R')

# Die Menge der Last in Norwegen, die durch das Kabel ersetzt werden kann, wird begrenzt.
max_load_cover_no     <- 30000   
idx_cable_no          <- which(grid_exist[,2] == 900 & grid_exist[,1]<200)
grid_exchange_1       <- grid_exist

#----------------------------------------
# ZEITMESSUNGENS VEKTOREN INITIALISIEREN
#----------------------------------------
time_5 		<- numeric(timesteps) # Vektor fuer Zeitmessung von einer viertelstunde
time_7 		<- numeric(timesteps) # Vektor fuer Zeitmessung von exchange
time_9 		<- numeric(timesteps) # Vektor fuer Zeitmessung von exchange_pump

#-------------------------------
# BEGINN VIERTELSTUNDEN-SCHLEIFE
#-------------------------------

for (i in start_timestep:end_timestep){ 
  hour 		<- i # Zum schreiben in die Datenbank wird hour dem Zeitschritt zugeordnet.
  print(i)
  t_5 		<- Sys.time()
  
  #--------------
  # FILLING LEVEL
  #--------------
  
  source('code_R_filling_level.R')  # Damit wird die moegliche zu produzierende Menge der Pumpen und Turbinen bestimmt.
  source('code_R_filling_level_other')
  source('code_R_filling_level_bio')

  #-----
  # BMO
  #-----
  # falls Winter ist muessen die waermegefuehrten Kraftwerke Pinst null bekommen
  # sie stehen dem Strommarkt nicht frei zur Verfuegung, sondern der Stromteil ist must-run.
  if(i <= 2190 || i > 6570){ 
    source('code_R_bmo_quarter')
  }

  # vier Spalten der data-frames von pp und turb werden untereinander geschrieben, nur Kraftwerke die auch anbieten
  turb_fuel 		<- matrix(rep("hydro",length(turb_data[,1])), ncol = 1)
  colnames(turb_fuel) 	<- "fuel"
  turb_co2 		<- matrix(rep(0,length(turb_fuel)), ncol = 1)
  colnames(turb_co2) 	<- "co2"
  
  pp_turb_pre 		<- cbind(turb_data,turb_fuel,turb_co2)
  colnames(pp_turb_pre) 	<- c("pp_nr","pinst","Cmar","reg", "fuel", "co2")

  bio_fuel <- matrix(rep("bio", length(biomass_nr)), ncol = 1)
  bio_co2 <- matrix(rep(0,length(biomass_nr)), ncol = 1)
  bio_data_pre <- cbind(bio_data, bio_fuel, bio_co2)
  colnames(bio_data_pre) <- c("pp_nr","pinst","Cmar","reg", "fuel", "co2")

  other_fuel <- matrix(rep("other_stor", length(stor_oth_nr)), ncol = 1)
  other_co2 <- matrix(rep(0,length(stor_oth_nr)), ncol = 1)
  other_turb_data_pre <- cbind(other_turb_data, other_fuel, other_co2)
  colnames(other_turb_data_pre) <- c("pp_nr","pinst","Cmar","reg", "fuel", "co2")

  pp_data     <- subset(pp_data, select = c("pp_nr","pinst","Cmar","reg", "fuel", "co2"), pinst > 0)
  pp_turb_data <- rbind(pp_data, pp_turb_pre, bio_data_pre, other_turb_data_pre)
  pp_turb_data <- subset(pp_turb_data, pinst > 0, )
  
  bmo_list 		    <- vector("list",region_split)

  # BEGINN REGIONENSCHLEIFE

  idx_mar 			<- numeric(region_split) # Vektor um die Indizes der Grenzkraftwerke zu speichern
  
  for(r in 1:region_split){
    pp_part 			<- subset(pp_turb_data, reg %in% region_list[[r]])
    idx_pp_part 		<- order(pp_part$Cmar)
    pp_part_sorted 		<- pp_part[idx_pp_part,]
    Pcum 		        <- cumsum(pp_part_sorted$pinst)
    bmo 		        <- cbind(pp_part_sorted,Pcum)
    bmo_list[[r]] 		<- cbind(pp_part_sorted,Pcum)

    # Index Grenzkraftwerk marginal_idx in einer Viertelstunde i fuer die aktuelle Region r herausfinden
    mar 			<- f_marginal_idx(rl_reg[i,r],bmo$Pcum,bmo$Cmar)
    # wenn idx_mar Null ist, da die Nachfrage unter Null ist, wird der Preis automatisch Null
    idx_mar[r] 		        <- as.numeric(as.character(mar[,1]))
    price_start[i,r] 		<- as.numeric(as.character(mar[,2]))
    negative_demand[i,r] 	<- as.numeric(as.character(mar[,3]))
    over_demand[i, r] 		<- as.numeric(as.character(mar[,4]))

  } # Regionen-Schleife zuende denn jetzt beginnt der Austausch, noch innerhalb der Viertelstunden-Schliefe
  
  #------------------------
  # LASTDECKUNG DURCH KABEL
  #------------------------
  # Die Menge der Last in Norwegen, die durch das Kabel ersetzt werden kann, wird begrenzt.
  max_load_cover_no     <- 30000 
  idx_cable_no          <- which(grid_exist[,2] == 900 & grid_exist[,1]<200)
  grid_exchange_1       <- grid_exist
  
  #---------------
  # NETZAUSGLEICH
  #---------------
  
  t_7 	<- Sys.time()
  
  #----------------------------------------------
  new  <- function_exchange(rl_reg[i,],
                            grid_exchange_1,
                            idx_mar,
                            price_start[i,],
                            bmo_list,
                            negative_demand[i,],		
                            over_demand[i,],
                            exchange_loops)	
  #----------------------------------------------
  
  t_8 	<- Sys.time()
  
  # Die Ergebnisse des exchange loop werden in die Matrizen geschrieben
  price_exchange [i,]     <- new$price
  negative_demand[i,]     <- new$neg_demand
  over_demand[i,]         <- new$ov_demand
  rl_exchange[i,]         <- new$RL
  
  if(i == 1){
    exchange_combined 	<- new$grid
  }else{
    exchange_combined 	<- rbind(exchange_combined, new$grid)
  }
  
  #------------------
  # START ZWEITE REGIONEN-SCHLEIFE
  #------------------
  
  for (r in 1:region_split){

  # Die Kraftwerksdaten bmo auf der bmo Liste ziehen
  
    bmo                 <- bmo_list[[r]]
          
    #------------------
    # PRODUKTION DER KRAFTWERKE
    #------------------
    if (new$index[r]>0){
          
      pinst_used                  <- bmo$pinst[1:new$index[r]]
      if (new$index[r]==1){
        pinst_used[new$index[r]]   <- min(new$RL[r], pinst_used[1])
      }else{
        pinst_used[new$index[r]]   <- min((new$RL[r] - bmo$Pcum[new$index[r]-1]), pinst_used[new$index[r]])
      }
      
      # co2 emissionen fuer diese Viertelstunde fuer diese Region werden in die co2 Ergebnis-Matrix geschrieben
      co2[i,r]  		<- sum( pinst_used * bmo$co2[1:new$index[r]] / 4 ) 
      # MW * tCO2/MWh * 1/4 h = t CO2 in der 1/4h

      idx_unit_region             <- match(bmo$pp_nr, unit_standard)
      idx_used                    <- idx_unit_region[1:new$index[r]]

      elp[i, idx_used]            <- pinst_used
      
      for(fu in 1:length(fuel_standard)){
        idx_fuel_region           <- intersect(idx_unit_region, c(fuel_unit_idx_list[[fu]]))
        elp_reg_fossil[((timesteps*(fu-1))+i),r]  <- sum(elp[i,idx_fuel_region])
      }   
    }else{
      co2[i,r] 			<- 0
    }
  } 

  #------------------------------------------------------
  # PMO VORBEREITUNG UND IN DER EIGENEN REGION PUMPEN
  #------------------------------------------------------

  source('code_R_pump_1')
  
  #---------------------------------------
  # UEBEERSCHUSS IN ANDERE REGIONEN PUMPEN (MENGE PUMPEN)
  #---------------------------------------
  
  t_9   <- Sys.time() 
  #----------------------------------------------
  new_pump <- function_exchange_pump(new$grid,
                                     pump_for_ex,
                                     grid_exist,
                                     exchange_loops, 
                                     over_ee_temp)
  #----------------------------------------------
  t_10 	<- Sys.time()
  
  elp_pump_ex[i,] <- new_pump$elp_pump_all
    
  exchange_pump_combined <- new_pump$exchange_pump_combined
  
  negative_demand_pump_ex[i,] <- new_pump$over_ee_temp
  
  #---------------------------------------------
  # PUMPEN AUS DER PMO BESTIMMEN (WELCHE PUMPEN)
  #----------------------------------------------

  source('code_R_pump_2') 
                       
  #------------------
  # NEUER FUELLSTAND 
  #------------------
  
  source('code_R_filling_level_tplus.R') # Damit wird der neue Fuellstand berechnet und in die Datenbank geschrieben.
  source('code_R_filling_level_tplus_bio')
  source('code_R_filling_level_tplus_other')
    
  # Zeitmessungen abspeichern
  t_6 		<- Sys.time()
  time_5[i] 	<- difftime(t_6, t_5, unit = c("secs"))
  time_7[i] 	<- difftime(t_8, t_7, unit = c("secs"))
  time_9[i] 	<- difftime(t_10, t_9, unit = c("secs"))

} # Viertelstunden-Schleife zuende
 
#----------------------
# ERGEBNISSE SPEICHERN
#----------------------
source('code_R_results.R')

