
# Water system recursion

#------------------------
# Funktionen definieren
#------------------------

# next higher reservoir
next_higher_res <- function(stor_nr){
  sql_res <- paste("SELECT res_nr 
                    FROM reservoir_turbine_upper 
                    WHERE stor_nr = '", stor_nr,"' 
                    ORDER BY res_nr", sep = "")
  res     <- dbGetQuery(con_baltic, sql_res)
  res     <- c(as.numeric(as.character(res$res_nr)))
  return(res)
}

# next higher plant
next_higher_stor <- function(res_nr){
  sql_stor <- paste("SELECT reservoir_turbine_lower.stor_nr 
                     FROM reservoir_turbine_lower, storage 
                     WHERE res_nr = '", res_nr,"' 
                     AND reservoir_turbine_lower.stor_nr = storage.stor_nr 
                     AND (storage.type = 'K' OR storage.type = 'PK') 
                     ORDER BY reservoir_turbine_lower.stor_nr", sep = "")
  stor      <- dbGetQuery(con_baltic, sql_stor)
  stor      <- c(as.numeric(as.character(stor$stor_nr)))
  
  return(stor)
}

storage_plants <- turb$turb_nr

res_list          <- list()
stor_list         <- list()
length(res_list)  <- length(storage_plants)
length(stor_list) <- length(storage_plants)

# Ebene 1
for (stor in storage_plants) {
  idx <- which(storage_plants == stor)
  res_next <- next_higher_res(stor)
  res_list[[idx]] <- res_next
  
  # Ebene 2a
  for(res_1 in res_next) {
    stor_next_2 <- next_higher_stor(res_1)
    if(length(stor_next_2) == 0) {next}
    stor_list[[idx]] <- c(stor_list[[idx]], stor_next_2)
       
    # Ebene 2b
    for(stor_2 in stor_next_2){
      res_next_2 <- next_higher_res(stor_2)
      if(length(res_next_2) == 0){next}
      res_list[[idx]] <- c(res_list[[idx]], res_next_2)
      
      # Ebene 3a
      for(res_2 in res_next_2){
        stor_next_3 <- next_higher_stor(res_2)
        if(length(stor_next_3) == 0) {next}
        stor_list[[idx]] <- c(stor_list[[idx]], stor_next_3)
        
        # Ebene 3b
        for(stor_3 in stor_next_3){
          res_next_3 <- next_higher_res(stor_3)
          if(length(res_next_3) == 0){next}
          res_list[[idx]] <- c(res_list[[idx]], res_next_3)
          
          # Ebene 4a
          for(res_3 in res_next_3){
            stor_next_4 <- next_higher_stor(res_3)
            if(length(stor_next_4) == 0) {next}
            stor_list[[idx]] <- c(stor_list[[idx]], stor_next_4)
            
            # Ebene 4b
            for(stor_4 in stor_next_4){
              res_next_4 <- next_higher_res(stor_4)
              if(length(res_next_4) == 0){next}
              res_list[[idx]] <- c(res_list[[idx]], res_next_4)
              
              # Ebene 5a
              for(res_4 in res_next_4){
                stor_next_5 <- next_higher_stor(res_4)
                if(length(stor_next_5) == 0) {next}
                stor_list[[idx]] <- c(stor_list[[idx]], stor_next_5)
                
                # Ebene 5b
                for(stor_5 in stor_next_5){
                  res_next_5 <- next_higher_res(stor_5)
                  if(length(res_next_5) == 0){next}
                  res_list[[idx]] <- c(res_list[[idx]], res_next_5)
                }              
              }
            }
          }
        }
      }
    }
  }
}
  

# Daten auswerten
# Unique eintraege

res_list_unique   <- lapply(res_list, unique)
stor_list_unique  <- lapply(stor_list, unique)

# Sum fil_max
idx_res      <- lapply(res_list_unique, function(x) match(x, res$res_nr))
fil_max_list <- lapply(idx_res, function(x) res$fil_max[x])

fil_max_sum  <- unlist(lapply(fil_max_list, sum))
names(fil_max_sum) <- storage_plants

fil_max_sum_energy <- fil_max_sum * efactor_upper[idx_up_turb_rev]
sum(fil_max_sum_energy)/1000

fil_max_energy <- fil_max * efactor_upper[idx_res_upper]
fil_max_energy <- ifelse(is.na(fil_max_energy), 0, fil_max_energy)
sum(fil_max_energy)/1000

# Flo
flo_list <- lapply(idx_res, function(x) res_flo[x])

flo_sum  <- unlist(lapply(flo_list, sum))
names(flo_sum) <- storage_plants

#  uflo
idx_stor_rec <- lapply(stor_list_unique, function(x) match(x, turb$turb_nr))
u_flo_list   <- lapply(idx_stor_rec, function(x) u_flo[x])

u_flo_sum    <- unlist(lapply(u_flo_list, sum))
u_flo_sum    <- u_flo_sum + u_flo
names(u_flo_sum) <- storage_plants
