if(Anlagenbestand=="new"){
# verteilung der instalierten Leistung heute
# Auswahl der Anlagen die im Betrachtungszeitraum liegen (Startjahr bis Endjahr)
idx_Anlagen <- which(Anlagen$Inbetriebnahme>=paste(Startjahr,"-01-01", sep=""))
Anlagen <- Anlagen[idx_Anlagen,]
  # mit passender GeoDBID
idx_Anlagen_RS <- which(Anlagen$GeoDBID %in% RS_GeoDBID$GeoDBID)
Anlagen_RS <- Anlagen[idx_Anlagen_RS,]
  # zuordnen der Regionalschluessel
Anlagen_RS <- merge(Anlagen_RS, RS_GeoDBID, by.x ="GeoDBID", by.y ="GeoDBID")
#Regionalschluessel <- sort(unique(Anlagen_RS$Regionalschluessel))
  # ohne passende GeoDBID
idx_Anlagen_notRS <- which(!Anlagen$GeoDBID %in% RS_GeoDBID$GeoDBID)
Anlagen_notRS <- Anlagen[idx_Anlagen_notRS,]

# Anlagen die nicht betrachtet werden
idx_Anlagen_Alt <- which(Anlagen$Inbetriebnahme<paste(Startjahr,"-01-01", sep=""))
Anlagen_Alt <- Anlagen[idx_Anlagen_Alt,]



# Verteilung der Anlagen auf Jahre und Kreise (mit Regionalschluessel)

# Start Schleife Verteilung auf Kreise
i1 <- 0
repeat{
  i1 <- i1+1
  if(i1>ncol(Leistung))break
  RS_select <- Regionalschluessel[i1]
  idx_Anlagen_select <- which(Anlagen_RS$Regionalschluessel==RS_select)
  Anlagen_select <- Anlagen_RS[idx_Anlagen_select,]
  
  # Start Schleife Verteilung auf Jahre
  j1 <- 0
  repeat{
    j1 <- j1+1
    if(j1>nrow(Leistung_RS))break
    idx_Anlagen_Jahr <- which(Anlagen_select$Inbetriebnahme>=paste(Startjahr+j1-1,"-01-01", sep="") & Anlagen_select$Inbetriebnahme<paste(Startjahr+j1,"-01-01", sep=""))
    Anlagen_Jahr <- Anlagen_select[idx_Anlagen_Jahr,]
    Leistung_RS[j1,i1] <- sum(Anlagen_Jahr$Nennleistung)
    Anzahl_RS[j1,i1] <- nrow(Anlagen_Jahr)
  }
  # Ende Schleife Verteilung auf Jahre
}
#Ende Schleife Verteilung auf Kreise

Leistung_RS_sum <- colSums(Leistung_RS)
Leistung_RS_sum_Jahr <- rowSums(Leistung_RS)
sum(Leistung_RS_sum)/1000

Anzahl_RS_sum <- colSums(Anzahl_RS)
Anzahl_RS_sum_Jahr <- rowSums(Anzahl_RS)
sum(Anzahl_RS_sum)

# Verteilung der Anlagen auf Jahre (ohne Regionalschluessel)

# Start Schleife Verteilung auf Jahre
j1 <- 0
repeat{
  j1 <- j1+1
  if(j1>nrow(Leistung_RS))break
  idx_Anlagen_notRS_Jahr <- which(Anlagen_notRS$Inbetriebnahme>=paste(Startjahr+j1-1,"-01-01", sep="") & Anlagen_notRS$Inbetriebnahme<paste(Startjahr+j1,"-01-01", sep=""))
  Anlagen_notRS_Jahr <- Anlagen_notRS[idx_Anlagen_notRS_Jahr,]
  Leistung_notRS_Jahr[j1,1] <- sum(Anlagen_notRS_Jahr$Nennleistung)
  Anzahl_notRS_Jahr[j1,1] <- nrow(Anlagen_notRS_Jahr)
  Leistung_notRS[j1,] <- if(Leistung_RS_sum_Jahr[j1]>0 & Leistung_notRS_Jahr[j1]>0){Leistung_notRS_Jahr[j1]*(Leistung_RS[j1,]/Leistung_RS_sum_Jahr[j1])}else 0
}
# Ende Schleife Verteilung auf Jahre

Leistung <- Leistung_RS + Leistung_notRS
Leistung_sum <- colSums(Leistung)
Leistung_sum_Jahr <- rowSums(Leistung)
sum(Leistung_sum)/1000

Anzahl_sum_Jahr <- Anzahl_RS_sum_Jahr + Anzahl_notRS_Jahr
sum(Anzahl_sum_Jahr)

# kummulierte Leistung
i2 <- 0
repeat{
  i2 <- i2+1
  if(i2>ncol(Leistung))break
  Leistung_kum[,i2] <- cumsum(Leistung[,i2])
}

dbWriteTable(con2, "Leistung_Kreis", data.frame(Leistung_kum), overwrite=TRUE)
}

if(Anlagenbestand=="old"){
  attach(Anlagen_Import)
  idx_JahrA <- which(row_names==paste(Startjahr))
  idx_JahrB <- which(row_names==paste(Endjahr))             
  i20 <-0
  repeat{
    i20 <- i20+1
    if(i20>length(Regionalschluessel))break
    Leistung_kum[paste(row_names[idx_JahrA]:row_names[idx_JahrB]),paste(Regionalschluessel[i20])] <- eval(parse(text = paste("X",Regionalschluessel[i20],"[",idx_JahrA,":",idx_JahrB,"]", sep="")))
  }
  detach(Anlagen_Import)
}
