# Berechnung und Auswahl des Verteilungsschluessel
if(Schluessel_Art=="stock"){
  Schluessel_Auswahl[1,paste(Regionalschluessel)] <- Leistung_kum[paste(Schluessel_Jahr),paste(Regionalschluessel)]
  Schluessel[1,paste(Regionalschluessel)] <- Schluessel_Auswahl[1,paste(Regionalschluessel)]/sum(Schluessel_Auswahl)
}


if(Schluessel_Art!="stock"){
  Art <- dbGetQuery(con4, paste("SELECT Regionalschluessel, ",Schluessel_Art," FROM kreis_weather", sep=""))
  rownames(Art) <- Art$Regionalschluessel
  Schluessel_Auswahl[1,paste(Regionalschluessel)] <- Art[paste(Regionalschluessel),Schluessel_Art]
  Schluessel[1,paste(Regionalschluessel)] <- Schluessel_Auswahl[1,paste(Regionalschluessel)]/sum(Schluessel_Auswahl)
}

# Manipulation des Verteilungsschluessels
# Bundeslaendern oder DPR-Regionen wird ein fester Prozentsatz des Zubaus zugewiesen (Unterverteilung in den Kreisen bleibt)
if(is.na(Korrektur_Art)==FALSE & is.na(Regional_nr_Auswahl)==FALSE){
  Regional <- if(Korrektur_Art=="state"){sort(unique(Kreis_Station$Land))}else if(Korrektur_Art=="dpr"){sort(as.numeric(unique(Kreis_Station$dpr)))}
  Korrektur_Regional <- matrix(nrow=3, ncol=length(Regional))
  colnames(Korrektur_Regional) <- Regional
  i4 <- 0
  repeat{
    i4 <- i4+1
    if(i4>length(Regional))break
    Regional_select <- Regional[i4]
    Kreis <- if(Korrektur_Art=="state"){Kreis_Station$Regionalschluessel[which(Kreis_Station$Land==Regional_select)]}else if(Korrektur_Art=="dpr"){Kreis_Station$Regionalschluessel[which(Kreis_Station$dpr==Regional_select)]}
    Korrektur_Regional[1,paste(Regional_select)] <- sum(Schluessel_Auswahl[1,paste(Kreis)])
  }
  Korrektur_Regional[2,] <- (Korrektur_Regional[1,]/sum(Korrektur_Regional[1,]))*100
  Verteilung_Regional <- Verteilung_Regional[which(Verteilung_Regional$Regional_nr==Regional_nr_Auswahl),2:(length(Regional)+1)]
  Verteilung_Regional[which(Verteilung_Regional==0)] <- NA
  Verteilung_Regional[which(Verteilung_Regional==500)] <- 0
  idx_Verteilung_Regional <- which(is.na(Verteilung_Regional)==FALSE)
  idx_not_Verteilung_Regional <- which(is.na(Verteilung_Regional)==TRUE)
  Verteilung_Korrektur <- (100-sum(Verteilung_Regional[idx_Verteilung_Regional])) /sum(Korrektur_Regional[2,idx_not_Verteilung_Regional])
  
  Korrektur_Regional[3,idx_not_Verteilung_Regional] <- Korrektur_Regional[2,idx_not_Verteilung_Regional]*Verteilung_Korrektur
  Schluessel[1,paste(Regionalschluessel)] <- NA
  i5 <- 0
  repeat{
    i5 <- i5 +1
    if(i5>length(idx_Verteilung_Regional))break
    Verteilung_Regional_select <- idx_Verteilung_Regional[i5]
    Korrektur_Regional[3,Verteilung_Regional_select] <- Verteilung_Regional[1,Verteilung_Regional_select]
  }
  i6 <- 0
  repeat{
    i6 <- i6 + 1
    if(i6>length(Regionalschluessel))break
    Kreis_select <- Regionalschluessel[i6]
    Kreis_Regional_select <- if(Korrektur_Art=="state"){Kreis_Station$Land[which(Kreis_Station$Regionalschluessel==Kreis_select)]}else if(Korrektur_Art=="dpr"){Kreis_Station$dpr[which(Kreis_Station$Regionalschluessel==Kreis_select)]}
    Schluessel[1,paste(Kreis_select)] <- (Korrektur_Regional[3,Kreis_Regional_select]/100)*(Schluessel_Auswahl[1,paste(Kreis_select)]/Korrektur_Regional[1,Kreis_Regional_select])
  }
}

# Berechnung des Schluessels fuer jedes Scenariojahr
Schluessel_scenario[paste(Startjahr:(Scenario_Startjahr-1)),] <- Leistung_kum[paste(Startjahr:(Scenario_Startjahr-1)),]/rowSums(Leistung_kum[paste(Startjahr:(Scenario_Startjahr-1)),])
Schluessel_scenario[paste(Scenario_Startjahr:Endjahr),paste(Regionalschluessel)] <- rep(Schluessel[,paste(Regionalschluessel)], each=(Endjahr-Scenario_Startjahr)+1)
