Warning <- c()

# scenario_Auswahl

# scenario_gesamt <- dbGetQuery(con_scenario, "SELECT*FROM scenario_nr")
# scenario_gesamt <- scenario_gesamt[which(scenario_gesamt$scenario_nr==scenario_nr_vector),]

sql_solar_scenario  <- paste("SELECT * FROM solar_scenario WHERE scenario_solar_nr = '",solar_scenario_nr,"' ", sep = "")
scenario_solar      <- dbGetQuery(con_scenario, sql_solar_scenario)

# 
# if(length(scenario_nr_vector)>0){
#   scenario_solar_nr_vector <- scenario_gesamt$solar_scenario_nr
# }
# scenario_solar <- scenario_solar[which(scenario_solar$solar_scenario_nr==solar_scenario_nr_vector),]



# Anlagen

# Daten werden aus der Datenbank geladen
# Datenbank energymap: Datenbasis der installierten Leistung heute
Startjahr <- 1980
Endjahr <- 2050

Anlagenbestand <- scenario_solar$installations

if(Anlagenbestand=="new"){
  Anlagen <- dbGetQuery(con2, "SELECT*FROM energymap")
  RS_GeoDBID <- dbGetQuery(con4, "SELECT*FROM rs_geodbid")
}else Anlagen_Import <- dbGetQuery(con2, "SELECT*FROM leistung_kreis")


Anlagen_Alternativ_Auswahl <- scenario_solar$installations_alternative
if(is.na(Anlagen_Alternativ_Auswahl)==FALSE & Anlagen_Alternativ_Auswahl!=""){
  Anlagen_Alternativ <- dbGetQuery(con4, "SELECT*FROM anlagenbestand_alternativ")
}

# Schluessel
Schluessel_Art <- scenario_solar$installations_distribution
Schluessel_Jahr <- scenario_solar$distribution_stock_year
if(Schluessel_Art=="stock" & (Schluessel_Jahr %in% (Startjahr:Endjahr)==FALSE)){
  Schluessel_Jahr <- 2010
  Warning <- c(Warning,"WARNING")
}


Korrektur_Art <- scenario_solar$distribution_manipulation
Regional_nr_Auswahl <- scenario_solar$distribution_manipulation_nr

if(is.na(Korrektur_Art)==FALSE & is.na(Regional_nr_Auswahl)==FALSE){
  if(Korrektur_Art=="state"){
    Verteilung_Regional <- dbGetQuery(con4, "SELECT*FROM verteilung_land")
  }
  if(Korrektur_Art=="dpr"){
    Verteilung_Regional <- dbGetQuery(con4, "SELECT*FROM verteilung_dpr")
  }

if(!Regional_nr_Auswahl %in% Verteilung_Regional$Regional_nr){
  Regional_nr_Auswahl <- NA
  Warning <- c(Warning,"WARNING")
}
}

# Scenario

scenario_Auswahl <- if("re_scenario" %in% ls()){re_scenario}else scenario_solar$RE_scenario
Scenario_Jahr <- if("scenario_year" %in% ls()){scenario_year}else scenario_solar$scenario_year

Scenario_Startjahr <- scenario_solar$scenario_startyear

#sql_re_scenario <- paste("SELECT scenario_name, scenario_year, solar FROM re_scenario WHERE scenario_name = '",re_scenario,"' AND country_id = '1'", sep = "")
sql_re_scenario <- paste("SELECT scenario_name, scenario_year, solar FROM re_scenario WHERE scenario_name = '",scenario_Auswahl,"' AND country_id = '1'", sep = "")

re_scenario_data <- dbGetQuery(con_scenario, sql_re_scenario)


# Repower

Anlagenersatz <- scenario_solar$installations_repowering
Lebensdauer <- scenario_solar$installations_lifetime
if(Lebensdauer>30){
  Lebensdauer <- 30
  Warning <- c(Warning,"WARNING")
}

# Module, Degradation, Modultemperatur

Module_nr_Auswahl <- scenario_solar$solarpanel_nr

if(is.na(Module_nr_Auswahl)==FALSE){
  Module <- dbGetQuery(con4, "SELECT * FROM module")
  Module <- Module[which(Module$Module_nr==Module_nr_Auswahl),]
  Module_Typ_nr_Auswahl <- Module$Typ_nr
  if(nrow(Module)==0){
    Module_nr_Auswahl <- NA
    Warning <- c(Warning,"WARNING")
  }
}


# Ausrichtung

Ausrichtung <- dbGetQuery(con4, "SELECT*FROM ausrichtung")

if(is.na(scenario_solar$orientation_nr)==FALSE){
  i21 <- 0
  Ausrichtung_nr_Auswahl <- c(0)
  Ausrichtung_laden <- strsplit(scenario_solar$orientation_nr, ",")
  repeat{
    i21 <-i21+1
    if(i21>length(Ausrichtung_laden[[1]]))break
    Ausrichtung_waehlen <- as.numeric(Ausrichtung_laden[[c(1,i21)]])
    Ausrichtung_nr_Auswahl <- unique(c(Ausrichtung_nr_Auswahl, Ausrichtung_waehlen))
  }
}else Ausrichtung_nr_Auswahl <- 0
if(length(which(!Ausrichtung_nr_Auswahl %in% Ausrichtung$Ausrichtung_nr)==TRUE)>0){
  Ausrichtung_nr_Auswahl <- unique(c(0, Ausrichtung_nr_Auswahl[which(Ausrichtung_nr_Auswahl %in% Ausrichtung$Ausrichtung_nr)]))
  Warning <- c(Warning,"WARNING")
  }


# Sonne

rad <- pi/180
deg <- 180/pi

quater_select <-scenario_solar$timesteps_quarter

Stdinterval <- if(quater_select=="yes"){4}else 1
WOZ <- rep(seq((0+(1/Stdinterval)), 24, by= (1/Stdinterval)), 365)
n <- rep(1:365, each=24*Stdinterval)

#DW <- 23.45 * sin((2*pi/365)*(n+284))
#TW <- 2*pi*(n-1)/365
#Et <- 0.017 + 0.428*cos(TW) - 7.351*sin(TW) - 3.349*cos(2*TW) - 9.371*sin(2*TW)

J <- 360*n/365
DW <- 0.3948-23.2559*cos(rad*(J+9.1))-0.3915*cos(rad*(2*J+5.4))-0.1764*cos(rad*(3*J+26))
Zgl <- 0.0066 + 7.3525 * cos(rad*(J+85.9)) + 9.9359 * cos(rad*(2*J+108.90)) + 0.3387*cos(rad*(3*J+105.2))



# Wetterdaten

Wetterjahr <- if(is.na(scenario_solar$weather_year)==TRUE){scenario_gesamt$weather_year}else scenario_solar$weather_year

Kreis_Station <- dbGetQuery(con4, "SELECT*FROM kreis_weather")
Regionalschluessel <-  Kreis_Station$Regionalschluessel

location <- dbGetQuery(con4, "SELECT*FROM weather_location")
location <- location[which(location[,paste("Jahr_", Wetterjahr, sep="")]=="x"),]
if(length(location)==0){
  Warning <- c(Warning,"WARNING")
}

# Einstrahlung
Albedo <- 0.2

# Modultemperatur

Modultemperatur_nr_Auswahl <- scenario_solar$temperature_nr
Modultemperatur_Art <- scenario_solar$temperature

if(is.na(Modultemperatur_nr_Auswahl)==FALSE & is.na(Module_nr_Auswahl)==FALSE){
  Modultemperatur <- dbGetQuery(con4, "SELECT*FROM modultemperatur")
  Modultemperatur <- Modultemperatur[which(Modultemperatur$Modultemperatur_nr==Modultemperatur_nr_Auswahl),]
  if(nrow(Modultemperatur)==0){
    Modultemperatur_nr_Auswahl <- NA
    Warning <- c(Warning,"WARNING")
}
}
if(is.na(Modultemperatur_nr_Auswahl)==FALSE & is.na(Modultemperatur_Art==TRUE)){
  Modultemperatur_nr_Auswahl <- NA
  Warning <- c(Warning,"WARNING")
}
if(is.na(Modultemperatur_nr_Auswahl)==TRUE & is.na(Modultemperatur_Art==FALSE)){
  Modultemperatur_Art <- NA
  Warning <- c(Warning,"WARNING")
}


# Degradation

Degradation_nr_Auswahl <- scenario_solar$degradation_nr

if(is.na(Degradation_nr_Auswahl)==FALSE & is.na(Module_nr_Auswahl)==FALSE){
  Degradation <- dbGetQuery(con4, "SELECT * FROM degradation")
  Degradation <- Degradation[which(Degradation$Degradation_Nr==Degradation_nr_Auswahl),]
  Degradation_Typ_nr_Auswahl <- Module$Typ_nr[which(Module$Typ_nr %in% Degradation$Typ_nr)]
  if(length(Degradation_Typ_nr_Auswahl)!=length(Degradation$Typ_nr)){
    Warning <- c(Warning,"WARNING")
  }
  if(length(Degradation_Typ_nr_Auswahl)==0){
    Degradation_nr_Auswahl <- NA
    Warning <- c(Warning,"WARNING")
  }


if(is.na(Module_nr_Auswahl)==FALSE & is.na(Degradation_nr_Auswahl)==TRUE & is.na(Modultemperatur_nr_Auswahl==TRUE)){
  Module_nr_Auswahl <- NA
  Warning <- c(Warning,"WARNING")
}
}
# Performance Ratio

Anlagentyp_nr_Auswahl <- scenario_solar$installations_type_nr
PR_nr_Auswahl <- scenario_solar$performance_ratio_nr

if(is.na(PR_nr_Auswahl)==FALSE & is.na(Anlagentyp_nr_Auswahl)==FALSE){
  PR <- dbGetQuery(con4, "SELECT * FROM performance_ratio")
  Anlagentyp <- dbGetQuery(con4, "SELECT * FROM anlagentyp")
  PR <- PR[which(PR$PR_nr==PR_nr_Auswahl),]
  Anlagentyp <- Anlagentyp[which(Anlagentyp$Anlagentyp_nr==Anlagentyp_nr_Auswahl),]
  PR_Typ_nr_Auswahl <- Anlagentyp$Typ_nr[which(Anlagentyp$Typ_nr %in% PR$Typ_nr)]
  if(length(PR_Typ_nr_Auswahl)!=length(PR$Typ_nr)){
    Warning <- c(Warning,"WARNING")
  }
  if(length(PR_Typ_nr_Auswahl)==0){
    Anlagentyp_nr_Auswahl <- NA
    PR_nr_Auswahl <- NA
  }
}



#Tabellen

#Anlagen
Leistung_RS <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))
Anzahl_RS <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))

Leistung_notRS <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))

Leistung_notRS_Jahr <- matrix(nrow=(Endjahr-Startjahr+1), ncol=1)
Anzahl_notRS_Jahr <- matrix(nrow=(Endjahr-Startjahr+1), ncol=1)

Leistung <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))
Leistung_kum <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))

#Schluessel
Schluessel <- matrix(nrow=1, ncol=length(Regionalschluessel))
Schluessel_Auswahl <- matrix(nrow=1, ncol=length(Regionalschluessel))
Schluessel_scenario <- matrix(nrow=(Endjahr-Startjahr)+1, ncol=length(Regionalschluessel))


#Scenario
scenario <- matrix(ncol=5, nrow=(Endjahr-Startjahr+1))
scenario_Kreis <- matrix(nrow=(Endjahr-Startjahr)+1, ncol=length(Regionalschluessel))
scenario_Kreis_Auswahl <- matrix(nrow=(Lebensdauer), ncol=length(Regionalschluessel))

#Repower
RePower_Kreis <- matrix(nrow=(Endjahr-Startjahr+1), ncol=length(Regionalschluessel))
  
#Module  
Module_Typ <- matrix(nrow=Lebensdauer, ncol=(1+length(Module_Typ_nr_Auswahl)))
Module_Typ_Anteil <- matrix(nrow=3, ncol=nrow(Module)) 
  
#Ausrichtung
#Ausrichtung

#Wetterdaten
Korrektur_GDT <- matrix(nrow=4, ncol=nrow(location))


#Einstrahlung
Station_WOZ <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_WOZ_Direkt <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_WOZ_Diffus <- matrix(nrow=length(WOZ), ncol=nrow(location))

Station <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_Direkt <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_Diffus <- matrix(nrow=length(WOZ), ncol=nrow(location))

#Temperatur
Station_Temperatur <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_Modultemperatur <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_Temperatur_korrektur <- matrix(nrow=length(WOZ), ncol=nrow(location))
Station_PR_Temperatur_korrektur <- matrix(nrow=1, ncol=nrow(location))

#Degradation
if(is.na(Degradation_nr_Auswahl)==FALSE & is.na(Module_nr_Auswahl)==FALSE){
Degradation_korrektur_Typ <- matrix(nrow=length(Degradation_Typ_nr_Auswahl), ncol=Lebensdauer)
}
Degradation_korrektur <- matrix(nrow=1, ncol=Lebensdauer)

#Performance Ratio
if(is.na(PR_nr_Auswahl)==FALSE & is.na(Anlagentyp_nr_Auswahl)==FALSE){
PR_korrektur_Typ <- matrix(nrow=length(PR_Typ_nr_Auswahl), ncol=Lebensdauer)
}
PR_korrektur <- matrix(nrow=1, ncol=Lebensdauer)

#Einspeisung
Einspeisung_Kreis <- matrix(nrow=length(WOZ), ncol=length(Regionalschluessel))
scenario_Kreis_korrigiert <- matrix(nrow=Lebensdauer, ncol=length(Regionalschluessel))
scenariojahr_Kreis <- matrix(nrow=1, ncol=length(Regionalschluessel))
Einspeisung_Kreis <- matrix(nrow=length(WOZ), ncol=length(Regionalschluessel))
Einspeisung_Kreis_korrigiert <- matrix(nrow=length(WOZ), ncol=length(Regionalschluessel))

#Tabellen beschriften
  #Anlagen
colnames(Leistung_RS) <- Regionalschluessel
rownames(Leistung_RS) <- Startjahr:Endjahr
colnames(Anzahl_RS) <- Regionalschluessel
rownames(Anzahl_RS) <- Startjahr:Endjahr
colnames(Leistung_notRS) <- Regionalschluessel
rownames(Leistung_notRS) <- Startjahr:Endjahr
rownames(Leistung_notRS_Jahr) <- Startjahr:Endjahr
rownames(Anzahl_notRS_Jahr) <- Startjahr:Endjahr
colnames(Leistung) <- Regionalschluessel
rownames(Leistung) <- Startjahr:Endjahr
colnames(Leistung_kum) <- Regionalschluessel
rownames(Leistung_kum) <- Startjahr:Endjahr

# scenario
rownames(scenario) <- Startjahr:Endjahr
colnames(scenario) <- c("Bestand_scenario", "scenario_neu", "Leistung_Summe", "RePower", "Leistung_neu")
rownames(scenario_Kreis) <- Startjahr:Endjahr
colnames(scenario_Kreis) <- Regionalschluessel

  #Schluessel
colnames(Schluessel) <- Regionalschluessel
colnames(Schluessel_Auswahl) <- Regionalschluessel
colnames(Schluessel_scenario) <- Regionalschluessel
rownames(Schluessel_scenario) <- Startjahr:Endjahr

# Repower
rownames(RePower_Kreis) <- Startjahr:Endjahr
colnames(RePower_Kreis) <- Regionalschluessel
  
#Module
rownames(Module_Typ) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)
colnames(Module_Typ) <- c("Leistung", paste("Typ", Module_Typ_nr_Auswahl))
rownames(Module_Typ_Anteil) <- c("Leistung", "Anteil", "Temperatur_Koeffizient")
colnames(Module_Typ_Anteil) <-  paste("Typ", Module_Typ_nr_Auswahl)

#Wetterdaten
colnames(Korrektur_GDT) <- location$Abk
rownames(Korrektur_GDT) <- c("G", "D", "T", "DzuG")

#Einstrahlung
colnames(Station_WOZ) <- location$Abk
colnames(Station_WOZ_Direkt) <- location$Abk
colnames(Station_WOZ_Diffus) <- location$Abk

colnames(Station) <- location$Abk
colnames(Station_Direkt) <- location$Abk
colnames(Station_Diffus) <- location$Abk

#Temperatur
colnames(Station_Temperatur) <- location$Abk
colnames(Station_Modultemperatur) <- location$Abk
colnames(Station_Temperatur_korrektur) <- location$Abk
colnames(Station_PR_Temperatur_korrektur) <- location$Abk


#Degradation
if(is.na(Degradation_nr_Auswahl)==FALSE & is.na(Module_nr_Auswahl)==FALSE){
colnames(Degradation_korrektur_Typ) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)
}
colnames(Degradation_korrektur) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)

#Performance Ratio
if(is.na(PR_nr_Auswahl)==FALSE & is.na(Anlagentyp_nr_Auswahl)==FALSE){
colnames(PR_korrektur_Typ) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)
}
colnames(PR_korrektur) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)

  #Einspeisung
colnames(Einspeisung_Kreis) <- Regionalschluessel
  
rownames(scenario_Kreis_korrigiert) <- paste((Scenario_Jahr-Lebensdauer+1):Scenario_Jahr)
colnames(scenario_Kreis_korrigiert) <- paste(Regionalschluessel)

colnames(scenariojahr_Kreis) <- paste(Regionalschluessel)

#colnames(Einspeisung_Kreis) <- paste(Regionalschluessel)

colnames(Einspeisung_Kreis_korrigiert) <- paste(Regionalschluessel)
